
include defines.inc
include macro.inc


;****************************************************************************;

.CODE

;----------------------------------------------------------------------------;

; -------------------------------------------
; -=* I-N-I-T---S-O-U-N-D---B-L-A-S-T-E-R *=-
; -------------------------------------------
SB_Init:
                pushad

                test    InitResources, IR_BUFALLOC
                jnz     SBab_9
                and     InitResources, not(IR_DMA)
                cmp     CFG_MixAudioMapB, 0
                jz      SBinit_9

                ;----------------------------------------------
                ;- Allocate physical memory for SB DMA buffer -
                ;----------------------------------------------
SB_AllocateBuffer:
                test    CFG_AudioProperties, SP_SBMODE2
                jnz     SBab_9

                ; try to use internal buffer
                ;----------------------------
                cmp     CFG_SBBufferSize, sbintbuf_size
                jnc     SBab_2

                lea     eax, SBInternalBuffer
                mov     ebx, eax
                add     ebx, CFG_SBBufferSize
                cmp     ebx, 001000000h
                jnc     SBab_2
                xor     cl, cl  ; don't verify for VDS
                jmp     SBab_3
SBab_2:
                ; try to allocate physical memory via DOS & VDS
                ;-----------------------------------------------
                mov     ax, 00100h
                mov     ebx, CFG_SBBufferSize
                and     bl, 0F0h
                shr     ebx, 3      ; / 16 * 2
                add     ebx, 00100h ; additional 4096 bytes for page align
                int     31h
                jc      SBab_7
                mov     bufid_DataDMA, dx
                shl     eax, 4
                and     eax, 0000FFFFFh
                mov     cl, 1   ; verify for VDS
SBab_3:
                add     eax, 000000FFFh
                and     eax, 0FFFFF000h
                mov     ebx, eax
                and     ebx, 0FFFF0000h
                mov     edx, eax
                add     eax, CFG_SBBufferSize
                and     eax, 0FFFF0000h
                cmp     eax, ebx
                jz      SBab_4
                mov     edx, eax
SBab_4:
                mov     phys_DataDMA, edx
                mov     pmoffs_DataDMA, edx
                shr     edx, 4
                mov     rmbase_DataDMA, dx
                mov     eax, CFG_SBBufferSize
                cmp     eax, 001000h
                jc      SBab_5
                add     eax, 000000FFFh
                and     eax, 0FFFFF000h
                mov     CFG_SBBufferSize, eax
SBab_5:
                or      InitResources, IR_BUFALLOC
                test    cl, cl
                jz      SBab_8
                test    byte ptr ds:[0047Bh], 020h
                jz      SBab_8
                PSTR    TxtVDSFound
                ; lock DMA buffer
                mov     esi, pmoffs_DataDOS
                mov     eax, CFG_SBBufferSize
                mov     dword ptr [esi], eax
                mov     eax, phys_DataDMA
                mov     [esi + 004h], eax
                xor     eax, eax
                mov     [esi + 008h], eax
                mov     [esi + 00Ch], eax
                mov     ax, rmbase_DataDOS
                mov     V86regs._ES, ax
                xor     edi, edi
                mov     dx, 030h
                mov     ax, 08103h
                stc
                push    esi
                INTX    4Bh
                pop     esi
                jc      SBab_8
                mov     eax, [esi + 00Ch]
                or      ax, [esi + 00Ah]
                jnz     SBab_6
                dec     eax
                mov     [esi + 00Ch], eax
                mov     [esi + 00Ah], ax
                xor     edi, edi
                mov     dx, 030h
                mov     ax, 08103h
                stc
                push    esi
                INTX    4Bh
                pop     esi
                jc      SBab_8
                mov     eax, [esi + 00Ch]
                and     ax, [esi + 00Ah]
                inc     eax
                test    eax, eax
                jz      SBab_8
SBab_6:
                mov     eax, [esi + 00Ch]
                mov     phys_DataDMA, eax
                mov     ax, [esi + 00Ah]
                mov     bufid_DataDMA, ax
                or      InitResources, IR_PHYSBUF
                jmp     SBab_9
SBab_7:
                or      CFG_AudioProperties, SP_SBMODE2
SBab_8:
                and     InitResources, not(IR_PHYSBUF)
SBab_9:
                ; if Sound Blaster not used
                cmp     CFG_SBAddress, 0FFFFh
                jz      SBNoDevice
                ; if Sound Blaster already initialized
                test    InitResources, IR_SNDINIT
                jnz     SBinit_1

                PSTR    TxtInitSound
                mov     eax, 00A00h
;                lea     edx, INTTempTimer
;                call    GetSet_VectorHandler
                or      InitResources, IR_SNDINIT

                cmp     CFG_SBAddress, 0
                jnz     SB_GetDSPInfo

                ;------------------------------------------
                ;- Autodetect Sound Blaster base I/O port -
                ;------------------------------------------
SB_DetectPort:
                ; Simple DSP search
                mov     ecx, 3
SBdport_1:
                lea     esi, SBPossibleAddrs
SBdport_2:
                mov     dx, [esi]
                mov     CFG_SBAddress, dx
                cmp     dx, 0FFFFh
                jz      SBdport_3
                call    SB_Reset
                jnc     SBdport_9
                lea     esi, [esi + 2]
                jmp     SBdport_2
SBdport_3:
                PCHR    "."
                loop    SBdport_1

                ; Deep DSP search
                mov     ebx, 1
SBdport_4:
                lea     esi, SBPossibleAddrs
SBdport_5:
                ; look for valid SB address
                mov     edx, [esi]
                mov     CFG_SBAddress, dx
                cmp     dx, 0FFFFh
                jz      SBdport_8 ; end of table

                ; send reset command to DSP
                mov     al, 3
                add     dl, 006h
                out     dx, al ; write "1" to 02X6h
                DELAY   1
                xor     al, al
                out     dx, al ; write "0" to 02X6h

                ; wait for read ability
                DELAY   1

                mov     ecx, 01000h
SBdport_6:
                call    SB_ReadByte
                jc      SBdport_7
                ; look for valid response
                cmp     al, 0AAh
                loopnz  SBdport_6
                jz      SBdport_9
SBdport_7:
                ; response timeout - let's try next base address
                lea     esi, [esi + 2]
                PCHR    "."
                jmp     SBdport_5
SBdport_8:
                PCHR    "."
                dec     ebx
                jnz     SBdport_4
SB_NotFound:
                PENT
                PSTR    TxtSBFailed
                jmp     SBNoDevice
SB_NotResponding:
                PSTR    TxtSBNotRespond

                ;---------------------------------------------
                ;- Sound Blaster not found or not responding -
                ;---------------------------------------------
SBNoDevice:
                mov     IRQTestID, 0

                mov     CFG_SBAddress, 0FFFFh
                mov     eax, CFG_MixAudioMapB
                or      CFG_MixAudioMapA, eax
                mov     CFG_MixAudioMapB, 0
                jmp     SBinit_9
SBdport_9:
                PSTR    TxtSBFound

                ;------------------------------------------------
                ;- Sound Blaster found: get some info about DSP -
                ;------------------------------------------------
SB_GetDSPInfo:
                ; get DSP version
                PENT
                cmp     SBVersionHigh, 1
                jc      SBgdinfo_1
                cmp     SBVersionHigh, 4
                jna     SBgdinfo_5
SBgdinfo_1:
                mov     al, SBDSP_GET_VERSION
                call    SB_WriteByte
                call    SB_ReadByte
                mov     dh, al
                call    SB_ReadByte
                mov     dl, al
                mov     SBVersion, dx
SBgdinfo_2:
                PSTR    TxtSBVersion
                PDECB   SBVersionHigh
                PCHR    "."
                PDECB   SBVersionLow, 2
                PENT

                ; get DSP copyright string
                mov     al, 0E3h
                call    SB_WriteByte
                lea     ebx, TempBuffer_A
SBgdinfo_3:
                call    SB_Wait4Read
                jc      SBgdinfo_5
                call    SB_ReadByte
                mov     [ebx], al
                test    al, al
                jz      SBgdinfo_4
                inc     ebx
                cmp     ebx, tmpbufa_size
                jc      SBgdinfo_3
                dec     ebx
                mov     byte ptr [ebx], 0
SBgdinfo_4:
                lea     eax, TempBuffer_A
                cmp     eax, ebx
                jz      SBgdinfo_5
                PSTR    TxtSBManufacter
                PSTR    TempBuffer_A
                PENT
SBgdinfo_5:
                PSTR    TxtSBIoPort
                mov     ax, CFG_SBAddress
                xchg    al, ah
                PHEXN   al
                mov     al, ah
                PHEXB   al
                PENT
SBgdinfo_6:
                ; turn off FM chip
                mov     dx, CFG_SBAddress
                add     dl, 8
                call    AdLib_Reset
                cmp     SBVersion, 00201h
                jc      SBgdinfo_7
                mov     dx, CFG_SBAddress
                call    AdLib_Reset
                add     dl, 2
                call    AdLib_Reset
SBgdinfo_7:

                ;-------------------------------------------
                ;- Autodetect Sound Blaster interrupt line -
                ;-------------------------------------------
SB_DetectInterrupt:
                EINTS
                test    CFG_AudioProperties, SP_SBMODE2
                jnz     SBinit_1

                ; DMA mode selected, interrupt and DMA channel needed
                mov     cl, CFG_SBInterrupt
                test    cl, cl
                jnz     SBdint_8

                mov     IRQTestID, 0

                ; autodetect if IRQ=0
                mov     ax, VZXIntMasks
                lea     edi, SBPossibleIRQs
SBdint_1:
                mov     cx, [edi]
                cmp     cx, 0FFFFh
                jz      SBdint_2
                inc     edi
                mov     bx, 0FFFEh
                rol     bx, cl
                and     ax, bx
                jmp     SBdint_1
SBdint_2:
                call    PICs_Init
                mov     ecx, 30
SBdint_3:
                call    SB_Reset
                DELAY   100

                push    ecx
                xor     eax, eax
                lea     esi, IRQTestBuffer
                mov     [esi], eax
                mov     [esi + 004h], eax
                mov     [esi + 008h], eax
                mov     [esi + 00Ch], eax
                mov     [esi + 010h], eax
                mov     [esi + 014h], eax
                mov     [esi + 018h], eax
                mov     [esi + 01Ch], eax
                mov     IRQTestID, 1

                mov     ecx, SB_NUMOFINT
SBdint_4:
                ; send interrupt request commands
                mov     al, SBDSP_INTERRUPT_8
                call    SB_WriteByte
                jc      SB_NotResponding
                mov     al, SBDSP_INTERRUPT_16
                call    SB_WriteByte
                jc      SB_NotResponding
                mov     al, SBDSP_PAUSE_DAC
                call    SB_WriteByte
                jc      SB_NotResponding
                mov     al, 1
                call    SB_WriteByte
                jc      SB_NotResponding
                xor     al, al
                call    SB_WriteByte
                jc      SB_NotResponding
                DELAY   20
                loop    SBdint_4

                ; find interrupt line with maximum hits
                DELAY   20
                mov     IRQTestID, 0
                xor     eax, eax
                lea     edi, SBPossibleIRQs
SBdint_5:
                mov     bx, [esi]
                cmp     ax, bx
                jnc     SBdint_6
                cmp     bx, SB_NUMOFINT * 3
                jz      SBdint_55
                cmp     bx, SB_NUMOFINT * 2
                jz      SBdint_55
                cmp     bx, SB_NUMOFINT
                jnz     SBdint_6
SBdint_55:
                mov     al, [edi]
                rol     eax, 16
                mov     ax, [esi]
                mov     ebp, esi        ; remember offset for DMA autodetecting
SBdint_6:
                lea     esi, [esi + 2]
                inc     edi
                cmp     byte ptr [edi], 0
                jnz     SBdint_5

                pop     ecx
                ror     eax, 16
                test    al, al
                jnz     SBdint_7
                rol     eax, 16
                dec     ecx
                jnz     SBdint_3
                jmp     SB_NotResponding
SBdint_7:
                rol     eax, 16
                cmp     ax, SB_NUMOFINT
                jc      SB_NotResponding
SBdint_75:
                ror     eax, 16
                mov     CFG_SBInterrupt, al
                mov     cl, al

                PSTR    TxtSBInterrupt
                PDECB   CFG_SBInterrupt
                PENT
SBdint_8:
                mov     ax, 0FFFEh
                rol     ax, cl
                and     ax, VZXIntMasks
                mov     VZXIntMasks, ax
                call    PICs_Init

                ;----------------------------------------
                ;- Autodetect Sound Blaster DMA channel -
                ;----------------------------------------
SB_DetectDMA:
                mov     edx, 00104h
                test    CFG_MixStereo, 080h
                setnz   al
                or      dl, al
                test    CFG_AudioProperties, SP_SBMODE1
                setz    al
                shl     al, 1
                or      dl, al
                mov     SBMode, dl
                mov     esi, CFG_SBSampleRate
                call    SB_sr2tc

                mov     cl, CFG_SBDMAChannel
                cmp     cl, 8
                jc      SBinit_1

                or      CFG_AudioProperties, SP_SBMODE2
                call    SB_Reset

                lea     esi, SBPossibleDMAs
                mov     ax, [esi]
SBddma_1:
                call    DMA_Stop
                inc     esi
                mov     ax, [esi]
                cmp     ax, 0FFFFh
                jnz     SBddma_1

                DELAY   1

SBddma_2:
                lea     esi, SBPossibleDMAs
                mov     SBDMA8bit, -1
                mov     SBDMA16bit, -1
SBddma_3:
                mov     cx, [esi]
                cmp     cx, 0FFFFh
                jz      SBddma_7
                mov     CFG_SBDMAChannel, cl
                call    SB_StopDMA
                jc      SBddma_6

                mov     IRQTestID, 0
                mov     word ptr ds:[ebp], 0

                ; initialize SB and DMA channel
                push    ecx esi
                mov     esi, CFG_SBSampleRate
                mov     edi, pmoffs_DataDMA
                mov     ebx, phys_DataDMA
                mov     ecx, 4
                mov     IRQTestID, 1
                call    SB_StartDMA
;                mov     CFG_SBSampleRate, esi
                pop     esi ecx
                jc      SBddma_6
                push    ecx
                mov     ecx, 01000h
                xor     ah, ah
SBddma_31:
                call    DMA_GetRequests
                or      ah, al
                loopd   SBddma_31
                pop     ecx

                ; stop SB and DMA
                call    SB_StopDMA
                jc      SBddma_6
                mov     al, 1
                shl     al, cl
                and     al, ah
                jz      SBddma_6
                mov     ax, ds:[ebp]
                test    ax, ax
                jz      SBddma_6
                test    dl, 002h
                jnz     SBddma_4
                PSTR    TxtSB8bitDMA
                mov     SBDMA8bit, cl
                jmp     SBddma_5
SBddma_4:
                PSTR    TxtSB16bitDMA
                mov     SBDMA16bit, cl
SBddma_5:
                PDECB   cl
                PENT
SBddma_6:
                inc     esi
                jmp     SBddma_3
SBddma_7:
                test    CFG_AudioProperties, SP_SBMODE1 + SP_SBMODE2
                jz      SBddma_8
                mov     al, SBDMA8bit
                cmp     al, 8
                jc      SBddma_9
SBddma_8:
                mov     al, SBDMA16bit
                cmp     al, 8
                jc      SBddma_9
                test    dl, 010h
                jnz     SBddma_END
                xor     dl, 010h
                mov     SBMode, dl
                call    SB_Reset
                DELAY   1
                jmp     SBddma_2
SBddma_9:
                mov     CFG_SBDMAChannel, al
                mov     SBMode, dl
                and     CFG_AudioProperties, not(SP_SBMODE2)
SBddma_END:
                PENT

SBinit_1:
                test    CFG_AudioProperties, SP_SBMODE2
                jnz     SBinit_9
SBinit_2:
                mov     dl, SBMode
                call    SB_StopDMA
                DELAY   1
                call    SB_Reset
                DELAY   1
                or      InitResources, IR_DMA

                xor     edx, edx
                mov     eax, SBSampleRateRaised
                test    SBMode, 002h
                setnz   cl
                shl     eax, cl
                setc    dl
                mov     ebx, SynchroFreqRaised
                div     ebx
                not     cl
                and     al, cl
                mov     ebx, eax
                xor     edx, edx
                mov     eax, CFG_SBBufferSize
                sub     ebx, 1
                adc     ebx, 1
                div     ebx
                cmp     eax, 00100h
                setc    ah
                dec     ah
                or      al, ah
                setz    cl
                add     cl, al
                mov     al, cl
                xor     ah, ah
                mul     ebx
                mov     CFG_SBBufferSize, eax

                mov     dh, cl
                mov     esi, CFG_SBSampleRate
                mov     edi, pmoffs_DataDMA
                mov     ebx, phys_DataDMA
                mov     ecx, CFG_SBBufferSize
                mov     dl, SBMode
                or      dl, 0B8h
                mov     al, CFG_SBDMAChannel
                call    SB_StartDMA
                jnc     SBinit_5
                call    SB_StopDMA
                ; cannot initialize SB DMA for some reason, using direct mode at least
                or      CFG_AudioProperties, SP_SBMODE2
                and     InitResources, not(IR_DMA)
                jmp     SBinit_9
SBinit_5:
                mov     SBMode, dl
                mov     CFG_SBBufferSize, ecx
;                call    SB_StopDMA
                mov     eax, SBBlockSize
;                lea     eax, [eax*2]
                add     SBStartSampleOffs, eax
                ; setup SB interrupt handler
                mov     al, CFG_SBInterrupt
                mov     ah, 00Ah
                lea     edx, INTSoundBlaster
                call    GetSet_VectorHandler
SBinit_9:
                popad
                ret

;----------------------------------------------------------------------------;

SB_StartDMA:
                ;---------------------------------------------------
                ; Start DMA transfer with SB DSP
                ;---------------------------------------------------
                ; - in:
                ; EBX - DMA block physical start address
                ; ECX - DMA block size in bytes
                ; ESI - sample rate (if zero, do not setup)
                ; EDI - DMA block linear start address (if DL D5=1)
                ; DL  - D0: 0=mono, 1=stereo
                ;       D1: 0=8bit, 1=16bit
                ;       D2: 0=input, 1=output
                ;       D3: 0=silent, 1=enable speaker
                ;       D4: 0=single-cycle, 1=auto-init
                ;       D5: 0=single-, 1=multi-buffering
                ;       D7: 0=don't clear buffer, 1=clear buffer
                ; DH  - number of buffers: if D5 of DL is 1
                ; - out:
                ; ECX - corrected DMA block size in bytes
                ; CF  - NC: DMA transfer started
                ;        C: SB not responding
                ;---------------------------------------------------
                push    eax ebx edi ebp
                test    dh, dh
                jz      SBstartd_ERR
                cmp     SBVersion, 00400h
                jnc     SBstartd_5

                mov     al, SBDSP_TURN_OFF_SPEAKER
                test    dl, 008h
                jz      SBstartd_1
                mov     al, SBDSP_TURN_ON_SPEAKER
SBstartd_1:
                call    SB_WriteByte
                jc      SBstartd_ERR

                cmp     SBVersion, 00200h
                jnc     SBstartd_2
SBsdsb1_01:
                ; initializing SB1.xx: 8-bit mono, single-cycle DMA mode
                ;--------------------------------------------------------
                cmp     CFG_SBDMAChannel, 004h
                jnc     SBstartd_ERR
                and     dl, 0ECh
                ; setup time constant
                test    esi, esi
                jz      SBsdsb1_02
                mov     al, SBDSP_SET_TIME_CONSTANT
                call    SB_WriteByte
                jc      SBstartd_ERR
                call    SB_sr2tc
                jc      SBstartd_ERR
                call    SB_WriteByte
                jc      SBstartd_ERR
SBsdsb1_02:
                ; clear buffer
                test    dl, 080h
                jz      SBsdsb1_03
                call    SB_ClearBuffer
                jc      SBstartd_ERR
SBsdsb1_03:
                ; setup DMA channel
                mov     al, CFG_SBDMAChannel
                mov     ah, dl
                and     ah, 010h
                or      ah, 048h        ; single-cycle/auto-init output mode
                test    dl, 004h
                jnz     SBsdsb1_04
                mov     ah, dl
                and     ah, 010h
                or      ah, 044h        ; single-cycle/auto-init input mode
SBsdsb1_04:
                call    DMA_Start
                jc      SBstartd_ERR

                ; start SB DMA
                mov     al, SBDSP_SINGLE_8_OUT
                test    dl, 004h
                jnz     SBsdsb1_06
                mov     al, SBDSP_SINGLE_8_IN
SBsdsb1_06:
                mov     SBStartCmdString, 3
                mov     SBStartCmdString + 1, al
                call    SB_WriteByte
                jc      SBstartd_ERR
                call    SB_CalcSamples
                jc      SBstartd_ERR
                mov     SBStartCmdString + 2, al
                call    SB_WriteByte
                jc      SBstartd_ERR
                mov     al, ah
                mov     SBStartCmdString + 3, al
                call    SB_WriteByte
                jc      SBstartd_ERR
                jmp     SBstartd_6
SBstartd_2:
                mov     ax, SBVersion
                cmp     SBVersion, 00300h
                jnc     SBstartd_3
SBsdsb2_01:
                ; initializing SB2.01: 8-bit mono, single-cycle/auto-init DMA mode
                ;------------------------------------------------------------------
                cmp     CFG_SBDMAChannel, 004h
                jnc     SBstartd_ERR
                and     dl, 0FCh
                ; setup time constant
                test    esi, esi
                jz      SBsdsb2_02
                mov     al, SBDSP_SET_TIME_CONSTANT
                call    SB_WriteByte
                jc      SBstartd_ERR
                call    SB_sr2tc
                jc      SBstartd_ERR
                call    SB_WriteByte
                jc      SBstartd_ERR
SBsdsb2_02:
                test    dl, 010h
                jz      SBsdsb1_02
                ; clear buffer
                test    dl, 080h
                jz      SBsdsb2_03
                call    SB_ClearBuffer
                jc      SBstartd_ERR
SBsdsb2_03:
                ; setup DMA channel
                mov     al, CFG_SBDMAChannel
                mov     ah, 058h        ; auto-init output mode
                test    dl, 004h
                jnz     SBsdsb2_04
                mov     ah, 054h        ; auto-init input mode
SBsdsb2_04:
                call    DMA_Start
                jc      SBstartd_ERR

                ; setup block size
                mov     SBStartCmdString, 4
                mov     al, SBDSP_SET_BLOCK_SIZE
                mov     SBStartCmdString + 1, al
                call    SB_WriteByte
                jc      SBstartd_ERR
                call    SB_CalcSamples
                jc      SBstartd_ERR
                mov     SBStartCmdString + 2, al
                call    SB_WriteByte
                jc      SBstartd_ERR
                mov     al, ah
                mov     SBStartCmdString + 3, al
                call    SB_WriteByte
                jc      SBstartd_ERR

                ; start SB DMA
                mov     al, SBDSP_AUTO_8_OUT
                test    dl, 004h
                jnz     SBsdsb2_06
                mov     al, SBDSP_AUTO_8_IN
SBsdsb2_06:
                mov     SBStartCmdString, 1
                mov     SBStartCmdString + 4, al
                call    SB_WriteByte
                jc      SBstartd_ERR
                jmp     SBstartd_6
SBstartd_3:
                ; initializing SB3.00+: 8-bit mono/stereo, single-cycle/auto-init DMA mode
                ;--------------------------------------------------------------------------
SBsdsbp2_01:
                cmp     CFG_SBDMAChannel, 004h
                jnc     SBstartd_ERR
                and     dl, 0FDh
                test    dl, 004h
                jnz     SBsdsbp2_03
                ; store some mixer registers
                mov     al, 00Ch
                call    SB_MixerRead
                jc      SBstartd_ERR
                mov     SBMixerReg0x0C, 0FFh
                mov     SBMixerReg0x0C + 1, al
                mov     al, 00Eh
                call    SB_MixerRead
                jc      SBstartd_ERR
                mov     SBMixerReg0x0E, 0FFh
                mov     SBMixerReg0x0E + 1, al
                ; setup mono or stereo input mode
                mov     al, SBDSP_SET_MONO
                test    dl, 001h
                jz      SBsdsbp2_02
                mov     al, SBDSP_SET_STEREO
                jmp     SBsdsbp2_03
SBsdsbp2_02:
                call    SB_WriteByte
                jc      SBstartd_ERR
                jmp     SBsdsbp2_06
SBsdsbp2_03:
                ; setup mono or stereo output mode
                mov     al, 00Eh
                call    SB_MixerRead
                jc      SBstartd_ERR
                and     al, 0FDh
                test    dl, 001h
                jz      SBsdsbp2_04
                or      al, 002h
SBsdsbp2_04:
                mov     ah, al
                mov     al, 00Eh
                call    SB_MixerWrite
                jc      SBstartd_ERR
                ; temporary start DMA
                mov     al, CFG_SBDMAChannel
                push    ecx
                mov     ecx, 1
                mov     ah, 048h
                call    DMA_Start
                pop     ecx
                mov     eax, pmoffs_DataDMA
                mov     byte ptr [eax], 080h
                ; temporary start SB DMA
                xor     ah, ah
                xchg    ah, IRQTestID
                mov     al, SBDSP_SINGLE_8_OUT
                call    SB_WriteByte
                jc      SBsdsbp2_05
                xor     al, al
                call    SB_WriteByte
                jc      SBsdsbp2_05
                call    SB_WriteByte
                jc      SBsdsbp2_05
                DELAY   1
                mov     IRQTestID, ah
                jmp     SBsdsbp2_06
SBsdsbp2_05:
                mov     IRQTestID, ah
                jmp     SBstartd_ERR
SBsdsbp2_06:
                ; setup time constant
                test    esi, esi
                jz      SBsdsbp2_07
                mov     al, SBDSP_SET_TIME_CONSTANT
                call    SB_WriteByte
                jc      SBstartd_ERR
                call    SB_sr2tc
                jc      SBstartd_ERR
                call    SB_WriteByte
                jc      SBstartd_ERR
SBsdsbp2_07:
                ; turn off input/output filter
                test    dl, 004h
                jz      SBsdsbp2_08
                mov     al, 00Eh        ; for stereo output
                call    SB_MixerRead
                or      al, 020h
                mov     ah, al
                mov     al, 00Eh
                call    SB_MixerWrite
                jmp     SBsdsbp2_09
SBsdsbp2_08:
                mov     al, 00Ch        ; for stereo input
                call    SB_MixerRead
                or      al, 020h
                mov     ah, al
                mov     al, 00Ch
                call    SB_MixerWrite
SBsdsbp2_09:
                jmp     SBsdsb2_02

;                ; clear buffer
;                test    dl, 080h
;                jz      SBsdsbp2_10
;                call    SB_ClearBuffer
;                jc      SBstartd_ERR
;SBsdsbp2_10:
;                ; setup DMA channel
;                mov     al, CFG_SBDMAChannel
;                mov     ah, dl
;                and     ah, 010h
;                add     ah, 048h        ; single-cycle/auto-init output mode
;                test    dl, 004h
;                jnz     SBsdsbp2_11
;                mov     ah, dl
;                and     ah, 010h
;                mov     ah, 044h        ; single-cycle/auto-init input mode
;SBsdsbp2_11:
;                call    DMA_Start
;                jc      SBstartd_ERR
;
;                ; setup block size
;                mov     al, SBDSP_SET_BLOCK_SIZE
;                call    SB_WriteByte
;                jc      SBstartd_ERR
;                call    SB_CalcSamples
;                jc      SBstartd_ERR
;                call    SB_WriteByte
;                jc      SBstartd_ERR
;                mov     al, ah
;                call    SB_WriteByte
;                jc      SBstartd_ERR
;
;                ; start SB DMA
;                mov     al, SBDSP_FASTAUTO_8_OUT
;                mov     ah, SBDSP_FASTSINGLE_8_OUT
;                test    dl, 004h
;                jnz     SBsdsbp2_12
;                mov     al, SBDSP_FASTAUTO_8_IN
;                mov     ah, SBDSP_FASTSINGLE_8_IN
;SBsdsbp2_12:
;                test    dl, 010h
;                jnz     SBsdsbp2_13
;                mov     al, ah
;SBsdsbp2_13:
;                mov     SBStartCmdString, 1
;                mov     SBStartCmdString + 1, al
;                call    SB_WriteByte
;                jc      SBstartd_ERR
;                jmp     SBstartd_6
SBstartd_5:
                ; initializing SB4.00+: 8/16-bit mono/stereo, single-cycle/auto-init DMA mode
                ;-----------------------------------------------------------------------------
SBsdsb16_01:
                cmp     CFG_SBDMAChannel, 008h
                jnc     SBstartd_ERR
                ; setup sampling rate
                test    esi, esi
                jz      SBsdsb16_03
                mov     al, SBDSP_SET_SAMPLING_RATE_OUT
                test    dl, 004h
                jnz     SBsdsb16_02
                mov     al, SBDSP_SET_SAMPLING_RATE_IN
SBsdsb16_02:
                call    SB_WriteByte
                jc      SBstartd_ERR
                call    SB_sr2tc
                jc      SBstartd_ERR
                mov     eax, esi
                cmp     eax, 000010000h
                jnc     SBstartd_ERR
                xchg    al, ah
                call    SB_WriteByte
                jc      SBstartd_ERR
                mov     al, ah
                call    SB_WriteByte
                jc      SBstartd_ERR
SBsdsb16_03:
                ; clear buffer
                test    dl, 080h
                jz      SBsdsb16_04
                call    SB_ClearBuffer
                jc      SBstartd_ERR
SBsdsb16_04:
                ; setup DMA channel
                mov     al, CFG_SBDMAChannel   ; assume 16-bit DMA
                test    dl, 002h
                jnz     SBsdsb16_05
                cmp     al, 4           ; 8-bit transfer requires only 8-bit DMA channel
                jnc     SBstartd_ERR
SBsdsb16_05:
                mov     ah, dl
                and     ah, 010h
                or      ah, 048h        ; single-cycle/auto-init output mode
                test    dl, 004h
                jnz     SBsdsb16_06
                mov     ah, dl
                and     ah, 010h
                or      ah, 044h        ; single-cycle/auto-init input mode
SBsdsb16_06:
                call    DMA_Start
                jc      SBstartd_ERR

                ; start SB DMA
                test    dl, 004h
                jnz     SBsdsb16_08
                mov     al, SBDSP_PROGRAM_8_IO + SBMODE_ADC + SBMODE_AUTO + SBMODE_FIFO_ON
                mov     ah, SBDSP_PROGRAM_8_IO + SBMODE_ADC + SBMODE_FIFO_ON
                test    dl, 002h
                jz      SBsdsb16_09
                mov     al, SBDSP_PROGRAM_16_IO + SBMODE_ADC + SBMODE_AUTO + SBMODE_FIFO_ON
                mov     ah, SBDSP_PROGRAM_16_IO + SBMODE_ADC + SBMODE_FIFO_ON
                jmp     SBsdsb16_09
SBsdsb16_08:
                mov     al, SBDSP_PROGRAM_8_IO + SBMODE_DAC + SBMODE_AUTO + SBMODE_FIFO_ON
                mov     ah, SBDSP_PROGRAM_8_IO + SBMODE_DAC + SBMODE_FIFO_ON
                test    dl, 002h
                jz      SBsdsb16_09
                mov     al, SBDSP_PROGRAM_16_IO + SBMODE_DAC + SBMODE_AUTO + SBMODE_FIFO_ON
                mov     ah, SBDSP_PROGRAM_16_IO + SBMODE_DAC + SBMODE_FIFO_ON
SBsdsb16_09:
                test    dl, 010h
                jnz     SBsdsb16_10
                mov     al, ah
SBsdsb16_10:
                mov     SBStartCmdString, 4
                mov     SBStartCmdString + 1, al
                call    SB_WriteByte
                jc      SBstartd_ERR
                mov     al, SBMODE_MONO + SBMODE_UNSIGNED
                test    dl, 001h
                jz      SBsdsb16_11
                mov     al, SBMODE_STEREO + SBMODE_UNSIGNED
SBsdsb16_11:
                mov     SBStartCmdString + 2, al
                call    SB_WriteByte
                jc      SBstartd_ERR
                call    SB_CalcSamples
                jc      SBstartd_ERR
                mov     SBStartCmdString + 3, al
                call    SB_WriteByte
                jc      SBstartd_ERR
                mov     al, ah
                mov     SBStartCmdString + 4, al
                call    SB_WriteByte
                jc      SBstartd_ERR
SBstartd_6:
                cmp     ebx, 0FFFFFFFFh
                jz      SBstartd_9
                mov     eax, edi
                mov     SBStartSampleOffs, eax
                mov     SBTotalBufferOffs, eax
                mov     SBPlayingBlockOffs, eax
                push    edx
                or      dl, 020h
                call    SB_CalcSamples
                pop     edx
                jc      SBstartd_ERR
                inc     eax
                test    dl, 002h
                jz      SBstartd_7
                shl     eax, 1
SBstartd_7:
                mov     SBBlockSize, eax
                add     edi, ecx
                dec     edi
                mov     SBTotalBufferEnd, edi
                clc
SBstartd_9:
                pop     ebp edi ebx eax
                ret
SBstartd_ERR:
                call    SB_Reset
                mov     SBStartCmdString, 0
                stc
                jmp     SBstartd_9

;----------------------------------------------------------------------------;

SB_StopDMA:
                ;----------------------------------
                ; Stop DMA transfer with SB DSP
                ;----------------------------------
                ; - in:
                ; DL  - D1: 0=8bit, 1=16bit
                ; - out:
                ; CF  - NC: DMA transfer stopped
                ;       C:  SB not responding
                ;----------------------------------
                pushad

                call    SB_AcknowledgeIRQ

                cmp     SBVersion, 00200h
                jnc     SBstopd_10
SBstopd_01:
                ; stopping SB1.xx: 8-bit mono, single-cycle DMA mode
                ;----------------------------------------------------
                ; pause/stop SB DMA
                mov     al, SBDSP_PAUSE_8_IO
                call    SB_WriteByte
                jc      SBstopd_90
                mov     al, SBDSP_EXIT_8_IO
                call    SB_WriteByte
                jc      SBstopd_90
                ; stop DMA
                mov     al, CFG_SBDMAChannel
                call    DMA_Stop
                jc      SBstopd_90
                jmp     SBstopd_80
SBstopd_10:
                cmp     SBVersion, 00300h
                jnc     SBstopd_20
SBstopd_11:
                ; stopping SB2.xx: 8-bit mono, single-cycle/auto-init DMA mode
                ;--------------------------------------------------------------
                ; pause/stop SB DMA
                mov     al, SBDSP_PAUSE_8_IO
                call    SB_WriteByte
                jc      SBstopd_90
                mov     al, SBDSP_EXIT_8_IO
                call    SB_WriteByte
                jc      SBstopd_90
                ; stop DMA
                mov     al, CFG_SBDMAChannel
                call    DMA_Stop
                jc      SBstopd_90
                jmp     SBstopd_80
SBstopd_20:
                cmp     SBVersion, 00400h
                jnc     SBstopd_40
SBstopd_31:
                ; stopping SB3.xx: 8-bit mono/stereo, single-cycle/auto-init fast DMA mode
                ;--------------------------------------------------------------------------
                ; restore mixer registers
                cmp     SBMixerReg0x0C, 0FFh
                jnz     SBstopd_32
                mov     al, 00Ch
                mov     ah, SBMixerReg0x0C + 1
                call    SB_MixerWrite
                jc      SBstopd_90
SBstopd_32:
                cmp     SBMixerReg0x0E, 0FFh
                jnz     SBstopd_33
                mov     al, 00Eh
                mov     ah, SBMixerReg0x0E + 1
                call    SB_MixerWrite
                jc      SBstopd_90
SBstopd_33:
                ; reset SB DSP - stops SB Pro DMA
                call    SB_Reset
                ; stop DMA
                mov     al, CFG_SBDMAChannel
                call    DMA_Stop
                jc      SBstopd_90
                jmp     SBstopd_80
SBstopd_40:
                ; stopping SB4.00+: 8/16-bit mono/stereo, single-cycle/auto-init DMA mode
                ;-------------------------------------------------------------------------
SBstopd_41:
                ; pause/stop SB DMA
                mov     al, SBDSP_PAUSE_8_IO
                mov     ah, SBDSP_EXIT_8_IO
                test    dl, 002h
                jz      SBstopd_42
                mov     al, SBDSP_PAUSE_16_IO
                mov     ah, SBDSP_EXIT_16_IO
SBstopd_42:
                call    SB_WriteByte
                jc      SBstopd_90
                mov     al, ah
                call    SB_WriteByte
                jc      SBstopd_90
                ; stop DMA
                mov     al, CFG_SBDMAChannel
                call    DMA_Stop
                jc      SBstopd_90
SBstopd_80:
                clc
                jmp     SBstopd_99
SBstopd_90:
                call    SB_Reset
                stc
SBstopd_99:
                popad
                ret

;----------------------------------------------------------------------------;

SB_CalcSamples:
                ;-------------------------------
                ; Calculate Samples to transfer
                ;-------------------------------
                ; - in:
                ; ECX - DMA buffer size in bytes
                ; DL  - D1: 0=8bit, 1=16bit
                ;       D5: 0=single-buffering,
                ;           1=multi-buffering
                ; DH  - number of buffers if D4 of DL is 1
                ; - out:
                ; CF  - NC: EAX - number of samples minus 1
                ;           ECX - corrected buffer size
                ;        C: any error
                ;-------------------------------
                push    ebx edx esi edi
                mov     ebx, edx
                test    bl, 020h
                jnz     SBcs_1
                mov     bh, 1
SBcs_1:
                sub     bh, 1
                adc     bh, 1
                movzx   edi, bh
                mov     eax, ecx
                xor     edx, edx
                div     edi
                mov     esi, eax
                test    bl, 002h
                jz      SBcs_2
                shr     esi, 1
SBcs_2:
                mov     eax, esi
                test    bl, 002h
                jz      SBcs_3
                shl     eax, 1
SBcs_3:
                mul     edi
                mov     ecx, eax
                mov     eax, esi
                sub     eax, 1
                adc     eax, 0
                pop     edi esi edx ebx
                clc
                ret

;----------------------------------------------------------------------------;

SB_sr2tc:
                ;----------------------------------
                ; Sampling Rate - to Time Constant
                ;----------------------------------
                ; - in:
                ; ESI - sampling rate
                ; DL  - 0=mono, 1=stereo
                ; - out:
                ; ESI - real sampling rate
                ; CF  - NC: AL = time constant
                ;       C:  time constant overflow
                ;----------------------------------
                push    eax ebx ecx edx
                mov     cl, dl
                and     cl, 001h
                shl     esi, cl
                mov     edx, (1000000 shr (32 - FREQ_RAISE))
                mov     eax, (1000000 shl FREQ_RAISE) and 0FFFFFFFFh
                div     esi
                test    eax, 0FFFFFF00h shl FREQ_RAISE
                jnz     SBr2t_1
                test    eax, (00100h shl FREQ_RAISE) - 1
                jz      SBr2t_1
                xor     ebx, ebx
                sub     ebx, eax
                jz      SBr2t_1
                shr     eax, FREQ_RAISE
                shr     ebx, FREQ_RAISE
                movzx   esi, al
                mov     edx, (1000000 shr (32 - FREQ_RAISE))
                mov     eax, (1000000 shl FREQ_RAISE) and 0FFFFFFFFh
                div     esi
                mov     SBSampleRateRaised, eax
                shr     eax, FREQ_RAISE
                mov     esi, eax
                mov     al, bl
                clc
                jmp     SBr2t_2
SBr2t_1:
                xor     al, al
                stc
SBr2t_2:
                mov     SBTimeConst, al
                pop     edx ecx ebx eax
                mov     al, SBTimeConst
                ret

;----------------------------------------------------------------------------;

SB_ClearBuffer:
                ;---------------------------------------------------
                ; Fill DMA block with SB silence value
                ;---------------------------------------------------
                ; - in:
                ; EDI - DMA block linear start address (if DL D5=1)
                ; ECX - DMA block size in bytes
                ; DL  - D1: 0=8bit, 1=16bit
                ; - out:
                ; CF  - NC: OK
                ;       C:  invalid counter (ECX=0)
                ;---------------------------------------------------
                test    ecx, ecx
                jz      SBcb_3
                push    es
                pushad
                mov     eax, ds
                mov     es, eax
                test    dl, 002h
                jz      SBcb_1
                ; 16-bit fill
                shr     ecx, 1
                mov     ax, 08000h
                cld
                rep     stos word ptr es:[edi]
                jmp     SBcb_2
SBcb_1:
                ; 8-bit fill
                mov     al, 080h
                cld
                rep     stos byte ptr es:[edi]
SBcb_2:
                popad
                pop     es
                clc
                ret
SBcb_3:
                stc
                ret

;----------------------------------------------------------------------------;

SB_Reset:
                push    eax edx ecx
                or      CriticalRuntime, CR_SBRESET
                cmp     CFG_SBAddress, 0FFFFh
                jz      SBrst_4
SBrst_1:
                movzx   edx, CFG_SBAddress
                add     dl, 006h
                mov     al, 1
                out     dx, al
                add     dl, 006h

                ; some delay
                mov     ecx, 0010h
SBrst_2:
                in      al, dx
                loop    SBrst_2

                sub     dl, 006h
                xor     al, al
                out     dx, al

                mov     ecx, 99
SBrst_3:
                call    SB_ReadByte
                jc      SBrst_4
                cmp     al, 0AAh
                loopnz  SBrst_3

                clc
                jz      SBrst_5
SBrst_4:
                stc
SBrst_5:
                setc    al
                and     CriticalRuntime, 0FFh - CR_SBRESET
                ror     al, 1
                pop     ecx edx eax
                ret

;----------------------------------------------------------------------------;

SB_AcknowledgeIRQ:
                push    edx
                mov     dl, al
                rol     edx, 16
                mov     dx, CFG_SBAddress
                add     dl, 00Eh
                in      al, dx
                cmp     SBVersion, 00400h
                jc      SBackirq_1

                inc     dl
                in      al, dx
SBackirq_1:
                ror     edx, 16
                mov     al, dl
                pop     edx
                ret

;----------------------------------------------------------------------------;

SB_Wait4Write:
                push    eax edx ecx
                mov     dx, CFG_SBAddress
                add     dl, 00Ch
                mov     ecx, 00100h
SBwfw_1:
                in      al, dx
                test    al, 080h
                loopnz  SBwfw_1
                ; no response
                stc
                jecxz   SBwfw_2
                clc
SBwfw_2:
                pop     ecx edx eax
                ret

;----------------------------------------------------------------------------;

SB_Wait4Read:
                push    eax edx ecx
                mov     dx, CFG_SBAddress
                add     dl, 00Eh
                mov     ecx, 00100h
SBwfr_1:
                in      al, dx
                test    al, 080h
                loopz   SBwfr_1
                sub     ecx, 1
                pop     ecx edx eax
                ret

;----------------------------------------------------------------------------;

SB_WriteSequence:
                push    edi ecx eax
                movzx   ecx, byte ptr [edi] ; number of bytes to send
                test    cl, cl
                jz      SBws_3              ; exit if null
SBws_1:
                inc     edi
                mov     al, [edi]
                call    SB_WriteByte
                loop    SBws_1
SBws_2:
                pop     eax ecx edi
                clc
                ret
SBws_3:
                pop     eax ecx edi
                stc
                ret

;----------------------------------------------------------------------------;

SB_WriteWord:
                mov     al, bl
                call    SB_WriteByte
                mov     al, bh
SB_WriteByte:
                call    SB_Wait4Write
                jc      SBwb_1
                push    edx
                mov     dx, CFG_SBAddress
                add     dl, 00Ch
                out     dx, al
                pop     edx
                clc
SBwb_1:
                ret

;----------------------------------------------------------------------------;

SB_ReadByte:
                call    SB_Wait4Read
                jc      SBrb_1
                push    edx
                mov     dx, CFG_SBAddress
                add     dl, 00Ah
                in      al, dx
                pop     edx
                clc
SBrb_1:
                ret

;----------------------------------------------------------------------------;

SB_MixerRead:
                push    edx
                mov     dx, CFG_SBAddress
                add     dl, 004h
                out     dx, al
                in      al, dx
                in      al, dx
                in      al, dx
                in      al, dx
                inc     dl
                in      al, dx
                pop     edx
                ret

;----------------------------------------------------------------------------;

SB_MixerWrite:
                push    edx
                mov     dx, CFG_SBAddress
                add     dl, 004h
                out     dx, al
                in      al, dx
                in      al, dx
                in      al, dx
                in      al, dx
                inc     dl
                mov     al, ah
                out     dx, al
                in      al, dx
                in      al, dx
                in      al, dx
                in      al, dx
                pop     edx
                ret

;----------------------------------------------------------------------------;

AdLib_Reset:
                push    eax ecx
                mov     ecx, 00100h
ALres_1:
                movzx   ax, cl
                call    AdLib_Write
                loop    ALres_1
                pop     ecx eax
                ret

;----------------------------------------------------------------------------;

AdLib_Write:
                push    ecx
                out     dx, al
                in      al, dx
                in      al, dx
                in      al, dx
                in      al, dx
                in      al, dx
                in      al, dx
                inc     dl
                mov     al, ah
                out     dx, al
                mov     ecx, 36
ALw_1:
                in      al, dx
                loop    ALw_1
                dec     dl
                pop     ecx
                ret

;----------------------------------------------------------------------------;

;****************************************************************************;

.DATA

SBPossibleAddrs     label   word
                    dw      00210h, 00220h, 00230h, 00240h, 00250h, 00260h, 00280h
                    dw      0FFFFh
SBPossibleIRQs      label   byte
                    db      002h, 003h, 005h, 007h, 009h, 00Ah, 00Bh, 00Ch, 00Fh
                    dw      0FFFFh
SBPossibleDMAs      label   byte
                    db      000h, 001h, 003h, 005h, 006h, 007h
                    dw      0FFFFh
SBStartCmdString    label   byte
                    db      8 dup(0)
SBVersion           label   word
SBVersionLow        db      0
SBVersionHigh       db      0
SBMode              db      0
SBDMA8bit           db      0
SBDMA16bit          db      0
SBMixerReg0x0C      db      0, 0
SBMixerReg0x0E      db      0, 0
SBStartSampleOffs   dd      0
SBPlayingBlockOffs  dd      0
SBTotalBufferOffs   dd      0
SBTotalBufferEnd    dd      0
SBBlockSize         dd      0
SBTimeConst         db      0
SBSampleRateRaised  dd      0
SBInternalBuffer    label   byte
                    db      0C000h dup(0)
sbintbuf_size=$-SBInternalBuffer
                    db      01000h dup(0)

;****************************************************************************
;* MESSAGES *****************************************************************
;****************************************************************************

TxtInitSound        db      " Initializing audio.", 0
TxtVDSFound         db      " Virtual DMA Services found.", 00Dh, 00Ah, 0
TxtSBFound          db      ". SB found:", 0
TxtSBVersion        db      "    Version      : ", 0
TxtSBManufacter     db      "    Manufacturer : ", 0
TxtSBIoPort         db      "    I/O Port     : ", 0
TxtSBInterrupt      db      "    Interrupt    : ", 0
TxtSB8bitDMA        db      "    DMA 8-bit    : ", 0
TxtSB16bitDMA       db      "    DMA 16-bit   : ", 0
TxtSBFailed         db      "Sound Blaster auto detection failed.", 00Dh, 00Ah, 0
TxtSBNotRespond     db      "Sound Blaster did not respond on selected port.", 00Dh, 00Ah, 0
TxtNoDMABuffer      db      "Could not allocate DMA buffer", 00Dh, 00Ah, 0


;****************************************************************************;


                end
