

;****************************************************************************;

.CODE

;----------------------------------------------------------------------------;

FDC_Init:
                    pushad

                    lea     eax, FDCDiskFilesTable
                    mov     [esi].FDCDisksTablePtr, eax

                    popad
                    ret

FDC_ReadStatusReg:
                    mov     ah, [esi].FDCFlgRegister
                    mov     al, [esi].FDCCommandState     ;   
;                    and     al, ah
                    and     al, [esi].FDCImageCurrent
                    mov     cl, [esi].FDCSectorNumber
                    inc     cl
                    mov     [esi].FDCSectorNumber, cl
                    test    cl, 00Eh
                    setz    cl
                    and     al, cl
                    rol     al, 3
                    and     al, [esi].FDCCommandState
                    ror     al, 2
                    xor     ah, al
                    mov     al, ah                  ;     
                    ror     al, 2                   ;    
                    or      al, [esi].FDCSttRegister;   7  
                    rol     al, 1
                    not     al
                    and     al, 080h
                    or      [esi].FDCSttRegister, al
                    mov     [esi].FDCFlgRegister, ah
                    ret

FDC_WriteTrackReg:
                    mov     [esi].FDCTrkRegister, ah
                    ret

FDC_ReadTrackReg:
                    mov     ah, [esi].FDCTrkRegister
                    ret

FDC_WriteSectorReg:
                    mov     [esi].FDCSecRegister, ah
                    ret

FDC_ReadSectorReg:
                    mov     ah, [esi].FDCSecRegister
                    ret

FDC_ReadDataReg:
                    mov     ah, [esi].FDCDatRegister
                    test    [esi].FDCSttRegister, 040h
                    jz      FDCrdat_1
                    test    [esi].FDCCommandState, 002h
                    jnz     FDCrdat_1
                    mov     ecx, [esi].FDCDataPointer
                    mov     ah, [ecx + [esi].FDCDataBuffer]
                    inc     ecx
                    mov     [esi].FDCDataPointer, ecx
                    cmp     ecx, [esi].FDCDataConst
                    jc      FDCrdat_1
                    mov     [esi].FDCSttRegister, 080h
                    and     [esi].FDCFlgRegister, 0FCh
FDCrdat_1:
                    ret

FDC_WriteCommandReg:
                    test    [esi].FDCFlgRegister, 001h
                    jnz     FDCwcmd_1
                    mov     [esi].FDCComRegister, ah
                    movzx   ecx, ah
                    jmp     [ecx*4 + offset FDCCommandTable]
FDCwcmd_1:
                    ret

FDC_WriteDataReg:
                    mov     [esi].FDCDatRegister, ah
                    test    [esi].FDCSttRegister, 040h
                    jz      FDCwdat_1
                    test    [esi].FDCCommandState, 002h
                    jz      FDCwdat_1
                    mov     ecx, [esi].FDCDataPointer
                    mov     [ecx + [esi].FDCDataBuffer], ah
                    inc     ecx
                    mov     [esi].FDCDataPointer, ecx
                    cmp     ecx, [esi].FDCDataConst
                    jc      FDCwdat_1
                    mov     [esi].FDCSttRegister, 080h
                    and     [esi].FDCFlgRegister, 0FCh
                    ;   
FDCwdat_1:
                    ret

FDC_WriteSystemReg:
                    test    [esi].FDCSysRegister, 004h
                    jnz     FDCwsys_1
                    test    ah, 004h
                    jz      FDCwsys_1
                    push    eax
                    call    FDCRestore7
                    pop     eax
                    mov     [esi].FDCSecRegister, 1
FDCwsys_1:
                    mov     cl, [esi].FDCSysRegister
                    and     ecx, 003h
                    mov     [esi].FDCSysRegister, ah
                    mov     eax, [esi].FDCCurDrvProperties
                    mov     [ecx*4 + [esi].FDCDriveAProperties], eax
                    mov     cl, [esi].FDCSysRegister
                    and     cl, 003h
                    mov     eax, [ecx*4 + [esi].FDCDriveAProperties]
                    mov     [esi].FDCCurDrvProperties, eax

FDC_ReadSystemReg:
                    mov     ah, [esi].FDCSttRegister
                    mov     al, [esi].FDCFlgRegister
                    xor     al, 001h
                    ror     al, 1
                    or      al, 07Fh
                    and     [esi].FDCSttRegister, al
                    ret

TRDClosCurrent:
                    test    [esi].FDCImageCurrent, 001h
                    jz      Trdcc1
                    call    File_Close
Trdcc1:
                    ret
TRDOpenCurrent:
                    push    eax edx
                    mov     [esi].FDCImageCurrent, 0
                    mov     al, [esi].FDCSysRegister
                    and     eax, 003h
                    mov     ecx, [esi].FDCDisksTablePtr
                    mov     edx, [eax*8 + ecx]
                    mov     al, FILE_OPEN_READWRITE
                    call    File_Open
                    jc      Trdoc1
                    mov     [esi].FDCImageCurrent, 1
Trdoc1:
                    pop     edx eax
                    ret
TRDWriteVerify:
;                    mov     ch, TRDWriteProtect
;                    mov     cl, FDCSysRegister
;                    and     cl, 003h
;                    inc     cl
;                    shr     ch, cl
                    or      al, al
                    ret
FDCRestore0:
FDCRestore1:
FDCRestore2:
FDCRestore3:
FDCRestore4:
FDCRestore5:
FDCRestore6:
FDCRestore7:
                    mov     al, 4
FdcR7_1:
                    call    TRDWriteVerify
                    jnc     FdcR7_2
                    or      al, 040h
FdcR7_2:
                    mov     [esi].FDCFlgRegister, al
                    mov     [esi].FDCTrkRegister, 0
                    mov     [esi].FDCSttRegister, 128
                    mov     [esi].FDCCommandState, 5
                    ret
FDCRestore8:
FDCRestore9:
FDCRestoreA:
FDCRestoreB:
                    call    TRDOpenCurrent
                    mov     al, 128
                    jc      FdcRB_2
                    mov     al, 36
FdcRB_1:
                    call    TRDWriteVerify
                    jnc     FdcRB_2
                    or      al, 040h
FdcRB_2:
                    mov     [esi].FDCFlgRegister, al
                    mov     [esi].FDCTrkRegister, 0
                    mov     [esi].FDCSttRegister, 128
                    mov     [esi].FDCCurDrvTrack, 0
                    mov     [esi].FDCCommandState, 13
                    jmp     TRDClosCurrent
FDCRestoreC:
FDCRestoreD:
FDCRestoreE:
FDCRestoreF:
                    call    TRDOpenCurrent
                    mov     al, 128
                    jc      FdcRF_2
                    mov     al, 36
FdcRF_1:
                    call    TRDWriteVerify
                    jnc     FdcRF_2
                    or      al, 040h
FdcRF_2:
                    mov     [esi].FDCFlgRegister, al
                    mov     [esi].FDCTrkRegister, 0
                    mov     [esi].FDCSttRegister, 128
                    mov     [esi].FDCCurDrvTrack, 0
                    mov     [esi].FDCCommandState, 13
                    jmp     TRDClosCurrent
FDCSeek0:
FDCSeek1:
FDCSeek2:
FDCSeek3:
FDCSeek4:
FDCSeek5:
FDCSeek6:
FDCSeek7:
                    mov     al, [esi].FDCDatRegister
                    sub     al, [esi].FDCTrkRegister
                    mov     cl, al
                    and     cl, 080h
                    rol     cl, 3
                    or      cl, 001h
                    mov     [esi].FDCCommandState, cl
                    mov     al, 0
                    cmp     [esi].FDCCurDrvTrack, 0
                    jnz     FdcS7_1
                    or      al, 004h
FdcS7_1:
                    call    TRDWriteVerify
                    jnc     FdcS7_2
                    or      al, 040h
FdcS7_2:
                    mov     [esi].FDCFlgRegister, al
                    mov     al, [esi].FDCDatRegister
                    mov     [esi].FDCTrkRegister, al
                    mov     [esi].FDCSttRegister, 128
                    ret
FDCSeek8:
FDCSeek9:
FDCSeekA:
FDCSeekB:
                    call    TRDOpenCurrent
                    mov     al, 128
                    jc      FdcSB_4
                    mov     al, 32
                    mov     ah, [esi].FDCDatRegister
                    sub     ah, [esi].FDCTrkRegister
                    mov     cl, ah
                    and     cl, 080h
                    rol     cl, 3
                    or      cl, 009h
                    mov     [esi].FDCCommandState, cl
                    add     [esi].FDCCurDrvTrack, ah
                    jno     FdcSB_2
FdcSB_1:
                    mov     [esi].FDCCurDrvTrack, 0
                    test    ah, ah
                    js      FdcSB_2
                    mov     [esi].FDCCurDrvTrack, 127
FdcSB_2:
                    cmp     [esi].FDCCurDrvTrack, 0
                    jnz     FdcSB_3
                    or      al, 004h
FdcSB_3:
                    call    TRDWriteVerify
                    jnc     FdcSB_4
                    or      al, 040h
FdcSB_4:
                    mov     [esi].FDCFlgRegister, al
                    mov     al, [esi].FDCDatRegister
                    mov     [esi].FDCTrkRegister, al
                    mov     [esi].FDCSttRegister, 128
                    jmp     TRDClosCurrent
FDCSeekC:
FDCSeekD:
FDCSeekE:
FDCSeekF:
                    call    TRDOpenCurrent
                    mov     al, 128
                    jc      FdcSF_4
                    mov     al, 32
                    mov     ah, [esi].FDCDatRegister
                    sub     ah, [esi].FDCTrkRegister
                    mov     cl, ah
                    and     cl, 080h
                    rol     cl, 3
                    or      cl, 009h
                    mov     [esi].FDCCommandState, cl
                    add     [esi].FDCCurDrvTrack, ah
                    jno     FdcSF_2
FdcSF_1:
                    mov     [esi].FDCCurDrvTrack, 0
                    test    ah, ah
                    js      FdcSF_2
                    or      al, 010h
                    mov     [esi].FDCCurDrvTrack, 127
FdcSF_2:
                    cmp     [esi].FDCCurDrvTrack, 0
                    jnz     FdcSF_3
                    or      al, 004h
FdcSF_3:
                    call    TRDWriteVerify
                    jnc     FdcSF_4
                    or      al, 040h
FdcSF_4:
                    mov     [esi].FDCFlgRegister, al
                    mov     al, [esi].FDCDatRegister
                    mov     [esi].FDCTrkRegister, al
                    mov     [esi].FDCSttRegister, 128
                    jmp     TRDClosCurrent
FDCStep00:
FDCStep01:
FDCStep02:
FDCStep03:
FDCStep04:
FDCStep05:
FDCStep06:
FDCStep07:
FDCStep08:
FDCStep09:
FDCStep0A:
FDCStep0B:
FDCStep0C:
FDCStep0D:
FDCStep0E:
FDCStep0F:
FDCStep10:
FDCStep11:
FDCStep12:
FDCStep13:
FDCStep14:
FDCStep15:
FDCStep16:
FDCStep17:
FDCStep18:
FDCStep19:
FDCStep1A:
FDCStep1B:
FDCStep1C:
FDCStep1D:
FDCStep1E:
FDCStep1F:
                    ret
FDCStepF00:
FDCStepF01:
FDCStepF02:
FDCStepF03:
FDCStepF04:
FDCStepF05:
FDCStepF06:
FDCStepF07:
                    mov     al, 0
                    cmp     [esi].FDCCurDrvTrack, 0
                    jnz     FdcSF07_1
                    or      al, 004h
FdcSF07_1:
                    call    TRDWriteVerify
                    jnc     FdcSF07_2
                    or      al, 040h
FdcSF07_2:
                    mov     [esi].FDCFlgRegister, al
                    mov     [esi].FDCSttRegister, 128
                    mov     [esi].FDCCommandState, 1
                    ret
FDCStepF08:
FDCStepF09:
FDCStepF0A:
FDCStepF0B:
                    call    TRDOpenCurrent
                    mov     al, 128
                    jc      FdcSF0B_4
                    mov     al, 32
                    inc     [esi].FDCCurDrvTrack
                    jno     FdcSF0B_2
                    mov     [esi].FDCCurDrvTrack, 127
FdcSF0B_2:
                    cmp     [esi].FDCCurDrvTrack, 0
                    jnz     FdcSF0B_3
                    or      al, 004h
FdcSF0B_3:
                    call    TRDWriteVerify
                    jnc     FdcSF0B_4
                    or      al, 040h
FdcSF0B_4:
                    mov     [esi].FDCFlgRegister, al
                    mov     [esi].FDCSttRegister, 128
                    mov     [esi].FDCCommandState, 9
                    jmp     TRDClosCurrent
FDCStepF0C:
FDCStepF0D:
FDCStepF0E:
FDCStepF0F:
                    call    TRDOpenCurrent
                    mov     al, 128
                    jc      FdcSF0F_4
                    mov     al, 32
                    inc     [esi].FDCCurDrvTrack
                    jno     FdcSF0F_2
                    or      al, 010h
                    mov     [esi].FDCCurDrvTrack, 127
FdcSF0F_2:
                    cmp     [esi].FDCCurDrvTrack, 0
                    jnz     FdcSF0F_3
                    or      al, 004h
FdcSF0F_3:
                    call    TRDWriteVerify
                    jnc     FdcSF0F_4
                    or      al, 040h
FdcSF0F_4:
                    mov     [esi].FDCFlgRegister, al
                    mov     [esi].FDCSttRegister, 128
                    mov     [esi].FDCCommandState, 9
                    jmp     TRDClosCurrent
FDCStepF10:
FDCStepF11:
FDCStepF12:
FDCStepF13:
FDCStepF14:
FDCStepF15:
FDCStepF16:
FDCStepF17:
                    inc     [esi].FDCTrkRegister
                    jmp     FDCStepF07
FDCStepF18:
FDCStepF19:
FDCStepF1A:
FDCStepF1B:
                    inc     [esi].FDCTrkRegister
                    jmp     FDCStepF0B
FDCStepF1C:
FDCStepF1D:
FDCStepF1E:
FDCStepF1F:
                    inc     [esi].FDCTrkRegister
                    jmp     FDCStepF0F
FDCStepB00:
FDCStepB01:
FDCStepB02:
FDCStepB03:
FDCStepB04:
FDCStepB05:
FDCStepB06:
FDCStepB07:
                    mov     al, 0
                    cmp     [esi].FDCCurDrvTrack, 0
                    jnz     FdcSB07_1
                    or      al, 004h
FdcSB07_1:
                    call    TRDWriteVerify
                    jnc     FdcSB07_2
                    or      al, 040h
FdcSB07_2:
                    mov     [esi].FDCFlgRegister, al
                    mov     [esi].FDCSttRegister, 128
                    mov     [esi].FDCCommandState, 5
                    ret
FDCStepB08:
FDCStepB09:
FDCStepB0A:
FDCStepB0B:
                    call    TRDOpenCurrent
                    mov     al, 128
                    jc      FdcSB0B_4
                    mov     al, 32
                    dec     [esi].FDCCurDrvTrack
                    jz      FdcSB0B_1
                    jns     FdcSB0B_2
                    mov     [esi].FDCCurDrvTrack, 0
FdcSB0B_1:
                    or      al, 004h
FdcSB0B_2:
                    call    TRDWriteVerify
                    jnc     FdcSB0B_4
                    or      al, 040h
FdcSB0B_4:
                    mov     [esi].FDCFlgRegister, al
                    mov     [esi].FDCSttRegister, 128
                    mov     [esi].FDCCommandState, 13
                    jmp     TRDClosCurrent
FDCStepB0C:
FDCStepB0D:
FDCStepB0E:
FDCStepB0F:
                    call    TRDOpenCurrent
                    mov     al, 128
                    jc      FdcSB0F_4
                    mov     al, 32
                    dec     [esi].FDCCurDrvTrack
                    jz      FdcSB0F_1
                    jns     FdcSB0F_2
                    mov     [esi].FDCCurDrvTrack, 0
FdcSB0F_1:
                    or      al, 004h
FdcSB0F_2:
                    call    TRDWriteVerify
                    jnc     FdcSB0F_4
                    or      al, 040h
FdcSB0F_4:
                    mov     [esi].FDCFlgRegister, al
                    mov     [esi].FDCSttRegister, 128
                    mov     [esi].FDCCommandState, 13
                    jmp     TRDClosCurrent
FDCStepB10:
FDCStepB11:
FDCStepB12:
FDCStepB13:
FDCStepB14:
FDCStepB15:
FDCStepB16:
FDCStepB17:
                    sub     [esi].FDCTrkRegister, 1
                    adc     [esi].FDCTrkRegister, 0
                    jmp     FDCStepB07
FDCStepB18:
FDCStepB19:
FDCStepB1A:
FDCStepB1B:
                    sub     [esi].FDCTrkRegister, 1
                    adc     [esi].FDCTrkRegister, 0
                    jmp     FDCStepB0B
FDCStepB1C:
FDCStepB1D:
FDCStepB1E:
FDCStepB1F:
                    sub     [esi].FDCTrkRegister, 1
                    adc     [esi].FDCTrkRegister, 0
                    jmp     FDCStepB0F
FDCReadSec00:
FDCReadSec01:
FDCReadSec02:
FDCReadSec03:
FDCReadSec04:
FDCReadSec05:
FDCReadSec06:
FDCReadSec07:
FDCReadSec08:
FDCReadSec09:
FDCReadSec0A:
FDCReadSec0B:
FDCReadSec0C:
FDCReadSec0D:
FDCReadSec0E:
FDCReadSec0F:
FDCReadSec10:
FDCReadSec11:
FDCReadSec12:
FDCReadSec13:
FDCReadSec14:
FDCReadSec15:
FDCReadSec16:
FDCReadSec17:
FDCReadSec18:
FDCReadSec19:
FDCReadSec1A:
FDCReadSec1B:
FDCReadSec1C:
FDCReadSec1D:
FDCReadSec1E:
FDCReadSec1F:
                    push    edx
                    mov     [esi].FDCSttRegister, 128
                    mov     [esi].FDCFlgRegister, 0
                    test    [esi].FDCCommandState, 008h
                    jz      FdcRS1F_2
                    mov     [esi].FDCFlgRegister, 128
                    call    TRDOpenCurrent
                    jc      FdcRS1F_2
                    mov     [esi].FDCFlgRegister, 16
                    mov     dl, [esi].FDCSecRegister
                    dec     dl
                    cmp     dl, 16
                    jnc     FdcRS1F_1
                    mov     al, [esi].FDCSysRegister
                    and     al, 010h
                    xor     al, 010h
                    or      dl, al
                    mov     dh, [esi].FDCCurDrvTrack
                    cmp     dh, [esi].FDCTrkRegister
                    jnz     FdcRS1F_1
                    shl     dl, 3
                    xor     ecx, ecx
                    shld    cx, dx, 5
                    shl     dx, 5
                    ; !!!!!
                    mov     al, FILE_SETPOS_FROMSTART
                    call    File_SetPosition
                    jc      FdcRS1F_1
                    mov     ecx, 00100h
                    lea     edx, [esi].FDCDataBuffer
                    call    File_Read
                    jc      FdcRS1F_1
                    mov     [esi].FDCFlgRegister, 3
                    mov     [esi].FDCSttRegister, 64
                    mov     [esi].FDCDataPointer, 0
                    mov     [esi].FDCDataConst, 256
                    and     [esi].FDCCommandState, 0FCh
FdcRS1F_1:
                    call    TRDClosCurrent
FdcRS1F_2:
                    pop     edx
                    ret
FDCWriteSec00:
FDCWriteSec01:
FDCWriteSec02:
FDCWriteSec03:
FDCWriteSec04:
FDCWriteSec05:
FDCWriteSec06:
FDCWriteSec07:
FDCWriteSec08:
FDCWriteSec09:
FDCWriteSec0A:
FDCWriteSec0B:
FDCWriteSec0C:
FDCWriteSec0D:
FDCWriteSec0E:
FDCWriteSec0F:
FDCWriteSec10:
FDCWriteSec11:
FDCWriteSec12:
FDCWriteSec13:
FDCWriteSec14:
FDCWriteSec15:
FDCWriteSec16:
FDCWriteSec17:
FDCWriteSec18:
FDCWriteSec19:
FDCWriteSec1A:
FDCWriteSec1B:
FDCWriteSec1C:
FDCWriteSec1D:
FDCWriteSec1E:
FDCWriteSec1F:
                    push    edx
                    mov     [esi].FDCSttRegister, 128
                    mov     [esi].FDCFlgRegister, 0
                    test    [esi].FDCCommandState, 008h
                    jz      FdcWS1F_2
                    mov     [esi].FDCFlgRegister, 128
                    call    TRDOpenCurrent
                    jc      FdcWS1F_2
                    mov     [esi].FDCFlgRegister, 16
                    mov     dl, [esi].FDCSecRegister
                    dec     dl
                    cmp     dl, 16
                    jnc     FdcWS1F_1
                    mov     al, [esi].FDCSysRegister
                    and     al, 010h
                    xor     al, 010h
                    or      dl, al
                    mov     dh, [esi].FDCCurDrvTrack
                    cmp     dh, [esi].FDCTrkRegister
                    jnz     FdcWS1F_1
                    shl     dl, 3
                    xor     ecx, ecx
                    shld    cx, dx, 5
                    shl     dx, 5
                    ; !!!!!
                    mov     al, FILE_SETPOS_FROMSTART
                    call    File_SetPosition
                    jc      FdcWS1F_1
;                    mov     ecx, 00100h
;                    lea     edx, [esi].FDCDataBuffer
;                    call    File_Read
;                    jc      FdcWS1F_1
                    mov     [esi].FDCFlgRegister, 3
                    mov     [esi].FDCSttRegister, 64
                    mov     [esi].FDCDataPointer, 0
                    mov     [esi].FDCDataConst, 256
                    and     [esi].FDCCommandState, 0FEh
                    or      [esi].FDCCommandState, 002h
FdcWS1F_1:
                    call    TRDClosCurrent
FdcWS1F_2:
                    pop     edx
                    ret
FDCReadAdr0:
FDCReadAdr4:
                    mov     [esi].FDCSttRegister, 128
                    mov     [esi].FDCFlgRegister, 0
                    test    [esi].FDCCommandState, 008h
                    jz      FdcRA4_1
                    mov     [esi].FDCFlgRegister, 128
                    call    TRDOpenCurrent
                    jc      FdcRA4_1
                    call    TRDClosCurrent
                    mov     [esi].FDCFlgRegister, 3
                    mov     [esi].FDCSttRegister, 64
                    mov     [esi].FDCDataPointer, 0
                    mov     [esi].FDCDataConst, 6
                    and     [esi].FDCCommandState, 0FCh
                    mov     al, [esi].FDCCurDrvTrack
                    mov     [esi].FDCDataBuffer, al
                    mov     [esi].FDCDataBuffer + 1, 0
                    mov     al, [esi].FDCSectorNumber
                    mov     [esi].FDCDataBuffer + 2, al
                    mov     [esi].FDCDataBuffer + 3, 1
FdcRA4_1:
                    mov     al, [esi].FDCTrkRegister
                    mov     [esi].FDCSecRegister, al
                    ret
FDCInterrupt0:
                    mov     [esi].FDCSttRegister, 0
                    and     [esi].FDCFlgRegister, 0FCh
                    and     [esi].FDCCommandState,0FCh
                    ret
FDCInterrupt1:
FDCInterrupt2:
FDCInterrupt3:
FDCInterrupt4:
FDCInterrupt5:
FDCInterrupt6:
FDCInterrupt7:
FDCInterrupt8:
FDCInterrupt9:
FDCInterruptA:
FDCInterruptB:
FDCInterruptC:
FDCInterruptD:
FDCInterruptE:
FDCInterruptF:
                    mov     [esi].FDCSttRegister, 128
                    and     [esi].FDCFlgRegister, 0FCh
                    and     [esi].FDCCommandState, 0FCh
                    ret
FDCReadTrk0:
FDCReadTrk4:
                     mov     [esi].FDCSttRegister, 128
                    ret
FDCFormat0:
FDCFormat4:
                     mov     [esi].FDCSttRegister, 128
                    ret

;----------------------------------------------------------------------------;


;****************************************************************************;

.DATA


FDCCommandTable     label   dword
                    dd      FDCRestore0,    FDCRestore1,    FDCRestore2,    FDCRestore3
                    dd      FDCRestore4,    FDCRestore5,    FDCRestore6,    FDCRestore7
                    dd      FDCRestore8,    FDCRestore9,    FDCRestoreA,    FDCRestoreB
                    dd      FDCRestoreC,    FDCRestoreD,    FDCRestoreE,    FDCRestoreF
                    dd      FDCSeek0,       FDCSeek1,       FDCSeek2,       FDCSeek3
                    dd      FDCSeek4,       FDCSeek5,       FDCSeek6,       FDCSeek7
                    dd      FDCSeek8,       FDCSeek9,       FDCSeekA,       FDCSeekB
                    dd      FDCSeekC,       FDCSeekD,       FDCSeekE,       FDCSeekF
                    dd      FDCStep00,      FDCStep01,      FDCStep02,      FDCStep03
                    dd      FDCStep04,      FDCStep05,      FDCStep06,      FDCStep07
                    dd      FDCStep08,      FDCStep09,      FDCStep0A,      FDCStep0B
                    dd      FDCStep0C,      FDCStep0D,      FDCStep0E,      FDCStep0F
                    dd      FDCStep10,      FDCStep11,      FDCStep12,      FDCStep13
                    dd      FDCStep14,      FDCStep15,      FDCStep16,      FDCStep17
                    dd      FDCStep18,      FDCStep19,      FDCStep1A,      FDCStep1B
                    dd      FDCStep1C,      FDCStep1D,      FDCStep1E,      FDCStep1F
                    dd      FDCStepF00,     FDCStepF01,     FDCStepF02,     FDCStepF03
                    dd      FDCStepF04,     FDCStepF05,     FDCStepF06,     FDCStepF07
                    dd      FDCStepF08,     FDCStepF09,     FDCStepF0A,     FDCStepF0B
                    dd      FDCStepF0C,     FDCStepF0D,     FDCStepF0E,     FDCStepF0F
                    dd      FDCStepF10,     FDCStepF11,     FDCStepF12,     FDCStepF13
                    dd      FDCStepF14,     FDCStepF15,     FDCStepF16,     FDCStepF17
                    dd      FDCStepF18,     FDCStepF19,     FDCStepF1A,     FDCStepF1B
                    dd      FDCStepF1C,     FDCStepF1D,     FDCStepF1E,     FDCStepF1F
                    dd      FDCStepB00,     FDCStepB01,     FDCStepB02,     FDCStepB03
                    dd      FDCStepB04,     FDCStepB05,     FDCStepB06,     FDCStepB07
                    dd      FDCStepB08,     FDCStepB09,     FDCStepB0A,     FDCStepB0B
                    dd      FDCStepB0C,     FDCStepB0D,     FDCStepB0E,     FDCStepB0F
                    dd      FDCStepB10,     FDCStepB11,     FDCStepB12,     FDCStepB13
                    dd      FDCStepB14,     FDCStepB15,     FDCStepB16,     FDCStepB17
                    dd      FDCStepB18,     FDCStepB19,     FDCStepB1A,     FDCStepB1B
                    dd      FDCStepB1C,     FDCStepB1D,     FDCStepB1E,     FDCStepB1F
                    dd      FDCReadSec00,   FDCReadSec01,   FDCReadSec02,   FDCReadSec03
                    dd      FDCReadSec04,   FDCReadSec05,   FDCReadSec06,   FDCReadSec07
                    dd      FDCReadSec08,   FDCReadSec09,   FDCReadSec0A,   FDCReadSec0B
                    dd      FDCReadSec0C,   FDCReadSec0D,   FDCReadSec0E,   FDCReadSec0F
                    dd      FDCReadSec10,   FDCReadSec11,   FDCReadSec12,   FDCReadSec13
                    dd      FDCReadSec14,   FDCReadSec15,   FDCReadSec16,   FDCReadSec17
                    dd      FDCReadSec18,   FDCReadSec19,   FDCReadSec1A,   FDCReadSec1B
                    dd      FDCReadSec1C,   FDCReadSec1D,   FDCReadSec1E,   FDCReadSec1F
                    dd      FDCWriteSec00,  FDCWriteSec01,  FDCWriteSec02,  FDCWriteSec03
                    dd      FDCWriteSec04,  FDCWriteSec05,  FDCWriteSec06,  FDCWriteSec07
                    dd      FDCWriteSec08,  FDCWriteSec09,  FDCWriteSec0A,  FDCWriteSec0B
                    dd      FDCWriteSec0C,  FDCWriteSec0D,  FDCWriteSec0E,  FDCWriteSec0F
                    dd      FDCWriteSec10,  FDCWriteSec11,  FDCWriteSec12,  FDCWriteSec13
                    dd      FDCWriteSec14,  FDCWriteSec15,  FDCWriteSec16,  FDCWriteSec17
                    dd      FDCWriteSec18,  FDCWriteSec19,  FDCWriteSec1A,  FDCWriteSec1B
                    dd      FDCWriteSec1C,  FDCWriteSec1D,  FDCWriteSec1E,  FDCWriteSec1F
                    dd      FDCReadAdr0,    FDCReadAdr0,    FDCReadAdr0,    FDCReadAdr0
                    dd      FDCReadAdr4,    FDCReadAdr4,    FDCReadAdr4,    FDCReadAdr4
                    dd      FDCReadAdr0,    FDCReadAdr0,    FDCReadAdr0,    FDCReadAdr0
                    dd      FDCReadAdr4,    FDCReadAdr4,    FDCReadAdr4,    FDCReadAdr4
                    dd      FDCInterrupt0,  FDCInterrupt1,  FDCInterrupt2,  FDCInterrupt3
                    dd      FDCInterrupt4,  FDCInterrupt5,  FDCInterrupt6,  FDCInterrupt7
                    dd      FDCInterrupt8,  FDCInterrupt9,  FDCInterruptA,  FDCInterruptB
                    dd      FDCInterruptC,  FDCInterruptD,  FDCInterruptE,  FDCInterruptF
                    dd      FDCReadTrk0,    FDCReadTrk0,    FDCReadTrk0,    FDCReadTrk0
                    dd      FDCReadTrk4,    FDCReadTrk4,    FDCReadTrk4,    FDCReadTrk4
                    dd      FDCReadTrk0,    FDCReadTrk0,    FDCReadTrk0,    FDCReadTrk0
                    dd      FDCReadTrk4,    FDCReadTrk4,    FDCReadTrk4,    FDCReadTrk4
                    dd      FDCFormat0,     FDCFormat0,     FDCFormat0,     FDCFormat0
                    dd      FDCFormat4,     FDCFormat4,     FDCFormat4,     FDCFormat4
                    dd      FDCFormat0,     FDCFormat0,     FDCFormat0,     FDCFormat0
                    dd      FDCFormat4,     FDCFormat4,     FDCFormat4,     FDCFormat4

;****************************************************************************;

