
include defines.inc
include macro.inc


;****************************************************************************;

.CODE


;----------------------------------------------------------------------------;

Kbd_Init:
                    ; reset keyboard
                    push    eax
                    mov     al, 0F4h
                    out     060h, al
                    DELAY   667
                    pop     eax
                    ret

;----------------------------------------------------------------------------;

Kbd_ClearSystemBuf:
                    push    eax
Kbdcsbuf_1:
                    ; verify if keyboard buffer is empty
                    mov     ah, 1
                    INTX    16h
                    jz      Kbdcsbuf_2
                    ; no, get key code
                    xor     ah, ah
                    INTX    16h
                    jmp     Kbdcsbuf_1
Kbdcsbuf_2:
                    pop     eax
                    ret

;----------------------------------------------------------------------------;

Kbd_Process:
                    cmp     KBDProcessFlag, 0
                    jz      Kbdproc_01
                    ret
Kbdproc_01:
                    inc     KBDProcessFlag
                    pushad

                    in      al, 064h
                    test    al, 020h
                    jnz     Kbdproc_End
                    mov     ah, al
                    in      al, 060h
                    test    al, al
                    jz      Kbdproc_End
                    cmp     al, 0FFh
                    jz      Kbdproc_End
                    cmp     al, KbdLastScanCode
                    jnz     Kbdproc_02
                    test    ah, 002h
                    jz      Kbdproc_End
Kbdproc_02:
                    mov     KbdLastScanCode, al
                    mov     ah, al
                    ; calculating key ID
                    test    KeyboardF5, 001h
                    jz      Kbdproc_03
                    dec     KeyboardF5
                    mov     al, 0F4h
                    out     060h, al
Kbdproc_03:
                    lea     esi, Kempston
                    mov     bl, KeyboardF4
                    mov     cl, bl
                    or      bl, KeyboardF5
                    and     ebx, 01Ch
                    test    ah, 080h
                    jz      Kbdproc_04
                    or      KeyboardF4, 002h
                    and     ah, 07Fh
Kbdproc_04:
                    test    cl, 001h
                    jz      Kbdproc_05
                    or      ah, 080h
Kbdproc_05:
                    movzx   edi, ah
                    shl     edi, 5
                    and     cl, 0FCh
                    lea     edi, [edi + ebx + ScanCodeTable]
                    test    KeyboardF4, 002h
                    mov     eax, [edi]
                    mov     KeyboardF4, cl
                    jnz     Kbdproc_break
Kbdproc_make:
                    ; key pressing handling
                    mov     bl, al
                    shr     bl, 4
                    and     al, 00Fh
                    inc     al
                    or      [esi + ebx], al
                    mov     bl, ah
                    shr     bl, 4
                    and     ah, 00Fh
                    inc     ah
                    or      [esi + ebx], ah
                    ror     eax, 16
                    mov     bl, al
                    shr     bl, 4
                    and     al, 00Fh
                    inc     al
                    or      [esi + ebx], al
                    test    ah, 0F0h
                    jz      Kbdproc_022
                    mov     bl, ah
                    shr     bl, 4
                    and     ah, 00Fh
                    inc     ah
                    xor     ah, 01Fh
                    and     [esi + ebx], ah
                    jmp     Kbdproc_022
Kbdproc_break:
                    ; key releasing handling
                    mov     cl, [edi + 3]
                    test    cl, 0F0h
                    mov     cl, 3
                    jz      Kbdproc_06
                    xor     cl, cl
Kbdproc_06:
                    mov     bl, al
                    shr     bl, 4
                    and     al, 00Fh
                    inc     al
                    shr     cl, 1
                    jnc     Kbdproc_07
                    or      [esi + ebx], al
                    jmp     Kbdproc_08
Kbdproc_07:
                    xor     al, 01Fh
                    and     [esi + ebx], al
Kbdproc_08:
                    mov     bl, ah
                    shr     bl, 4
                    and     ah, 00Fh
                    inc     ah
                    shr     cl, 1
                    jnc     Kbdproc_09
                    or      [esi + ebx], ah
                    jmp     Kbdproc_020
Kbdproc_09:
                    xor     ah, 01Fh
                    and     [esi + ebx], ah
Kbdproc_020:
                    ror     eax, 8
                    mov     bl, ah
                    shr     bl, 4
                    and     ah, 00Fh
                    inc     ah
Kbdproc_021:
                    xor     ah, 01Fh
                    and     [esi + ebx], ah
Kbdproc_022:
                    call    Kbd_ClearSystemBuf
                    test    KeyboardF3, 002h
                    jz      Kbdproc_End
                    ; terminate VZX by pressing <F12>
                    popad
                    dec     KBDProcessFlag
                    QUIT    TxtByeBye
Kbdproc_End:
                    popad
                    dec     KBDProcessFlag
                    ret

;----------------------------------------------------------------------------;

Kbd_WaitKeypress:
                    call    Kbd_ClearSystemBuf
                    push    eax
                    mov     ax, 05305h
                    INTX    15h
                    xor     eax, eax
                    mov     dword ptr KeyboardF0, eax
                    mov     dword ptr KeyboardF4, eax
                    mov     dword ptr KbdHalfrow0, eax
                    mov     dword ptr KbdHalfrow4, eax
Wkp_1:
                    call    TMR_ReadCounter
                    mov     ax, 01680h
                    INTX    2Fh
                    mov     eax, dword ptr KeyboardF0
                    or      eax, dword ptr KeyboardF4
                    or      eax, dword ptr KbdHalfrow0
                    or      eax, dword ptr KbdHalfrow4
                    jz      Wkp_1
                    mov     ax, 05306h
                    INTX    15h
                    pop     eax
                    ret

;----------------------------------------------------------------------------;


;****************************************************************************;

.DATA

KbdLastScanCode     db      0
KBDProcessFlag      db      0
Kempston            db      0           ;  kempston-:
                                        ;   D0     Left
                                        ;   D1     Right
                                        ;   D2     Up
                                        ;   D3     Down
                                        ;   D4     Fire
KbdHalfrow0         db      0           ;   : 4 ^^, 1 >>, 4 vv
KbdHalfrow1         db      0
KbdHalfrow2         db      0
KbdHalfrow3         db      0
KbdHalfrow4         db      0
KbdHalfrow5         db      0
KbdHalfrow6         db      0
KbdHalfrow7         db      0
KeyboardF0          db      0           ;    :
                                        ;   D0     Esc
                                        ;   D1     Print Screen
                                        ;   D2     Scroll Lock
                                        ;   D3     Pause
                                        ;   D4     Num Lock
KeyboardF1          db      0           ;   D0-D4  F1-F5
KeyboardF2          db      0           ;   D0-D4  F6-F10
KeyboardF3          db      0           ;   D0-D1  F11-F12
                                        ;   D2     KB error
                                        ;   D3     Ctrl+Alt+Del
                                        ;   D4     Unknown key scancode
KeyboardF4          db      0           ;   D0     Prefix E0h passed
                                        ;   D1     Prefix F0h passed (key release)
                                        ;   D2     Alt(L)
                                        ;   D3     Ctrl(L)
                                        ;   D4     Shift(L)
KeyboardF5          db      0           ;   D0     Prefix E1h passed (Pause)
                                        ;   D1     Null bit ("KBNUL")
                                        ;   D2     Alt(R)
                                        ;   D3     Ctrl(R)
                                        ;   D4     Shift(R)
KeyboardF6          db      0           ;   Reserved

ScanCodeTable       label   byte
                    ; KB error
                    db      0C3h, KBNUL,KBNUL,KBNUL,0C3h, KBNUL,KBNUL,KBNUL,0C3h, KBNUL,KBNUL,KBNUL,0C3h, KBNUL,KBNUL,KBNUL
                    db      0C3h, KBNUL,KBNUL,KBNUL,0C3h, KBNUL,KBNUL,KBNUL,0C3h, KBNUL,KBNUL,KBNUL,0C3h, KBNUL,KBNUL,KBNUL
                    ; Esc
                    db      090h, KBNUL,KBNUL,KBNUL,090h, KBNUL,KBNUL,KBNUL,090h, KBNUL,KBNUL,KBNUL,090h, KBNUL,KBNUL,KBNUL
                    db      090h, KBNUL,KBNUL,KBNUL,090h, KBNUL,KBNUL,KBNUL,090h, KBNUL,KBNUL,KBNUL,090h, KBNUL,KBNUL,KBNUL
                    ; "1"
                    db      040h, KBNUL,KBNUL,KBNUL,KBSYM,040h, KBNUL,KBNUL,KBSYM,040h, KBNUL,KBNUL,KBSYM,040h, KBNUL,KBNUL
                    db      KBCAP,040h, KBNUL,KBNUL,KBCAP,KBSYM,040h, KBNUL,KBCAP,KBSYM,040h, KBNUL,KBCAP,KBSYM,040h, KBNUL
                    ; "2"
                    db      041h, KBNUL,KBNUL,KBNUL,KBSYM,041h, KBNUL,KBNUL,KBSYM,041h, KBNUL,KBNUL,KBSYM,041h, KBNUL,KBNUL
                    db      KBCAP,041h, KBNUL,KBNUL,KBCAP,KBSYM,041h, KBNUL,KBCAP,KBSYM,041h, KBNUL,KBCAP,KBSYM,041h, KBNUL
                    ; "3"
                    db      043h, KBNUL,KBNUL,KBNUL,KBSYM,043h, KBNUL,KBNUL,KBSYM,043h, KBNUL,KBNUL,KBSYM,043h, KBNUL,KBNUL
                    db      KBCAP,043h, KBNUL,KBNUL,KBCAP,KBSYM,043h, KBNUL,KBCAP,KBSYM,043h, KBNUL,KBCAP,KBSYM,043h, KBNUL
                    ; "4"
                    db      047h, KBNUL,KBNUL,KBNUL,KBSYM,047h, KBNUL,KBNUL,KBSYM,047h, KBNUL,KBNUL,KBSYM,047h, KBNUL,KBNUL
                    db      KBCAP,047h, KBNUL,KBNUL,KBCAP,KBSYM,047h, KBNUL,KBCAP,KBSYM,047h, KBNUL,KBCAP,KBSYM,047h, KBNUL
                    ; "5"
                    db      04Fh, KBNUL,KBNUL,KBNUL,KBSYM,04Fh, KBNUL,KBNUL,KBSYM,04Fh, KBNUL,KBNUL,KBSYM,04Fh, KBNUL,KBNUL
                    db      KBCAP,04Fh, KBNUL,KBNUL,KBCAP,KBSYM,04Fh, KBNUL,KBCAP,KBSYM,04Fh, KBNUL,KBCAP,KBSYM,04Fh, KBNUL
                    ; "6"
                    db      05Fh, KBNUL,KBNUL,KBNUL,KBSYM,07Fh, KBNUL,KBNUL,KBSYM,05Fh, KBNUL,KBNUL,KBSYM,05Fh, KBNUL,KBNUL
                    db      KBCAP,05Fh, KBNUL,KBNUL,KBCAP,KBSYM,05Fh, KBNUL,KBCAP,KBSYM,05Fh, KBNUL,KBCAP,KBSYM,05Fh, KBNUL
                    ; "7"
                    db      057h, KBNUL,KBNUL,KBNUL,KBSYM,05Fh, KBNUL,KBNUL,KBSYM,057h, KBNUL,KBNUL,KBSYM,057h, KBNUL,KBNUL
                    db      KBCAP,057h, KBNUL,KBNUL,KBCAP,KBSYM,057h, KBNUL,KBCAP,KBSYM,057h, KBNUL,KBCAP,KBSYM,057h, KBNUL
                    ; "8"
                    db      053h, KBNUL,KBNUL,KBNUL,KBSYM,08Fh, KBNUL,KBNUL,KBSYM,053h, KBNUL,KBNUL,KBSYM,053h, KBNUL,KBNUL
                    db      KBCAP,053h, KBNUL,KBNUL,KBCAP,KBSYM,053h, KBNUL,KBCAP,KBSYM,053h, KBNUL,KBCAP,KBSYM,053h, KBNUL
                    ; "9"
                    db      051h, KBNUL,KBNUL,KBNUL,KBSYM,053h, KBNUL,KBNUL,KBSYM,051h, KBNUL,KBNUL,KBSYM,051h, KBNUL,KBNUL
                    db      KBCAP,051h, KBNUL,KBNUL,KBCAP,KBSYM,051h, KBNUL,KBCAP,KBSYM,051h, KBNUL,KBCAP,KBSYM,051h, KBNUL
                    ; "0"
                    db      050h, KBNUL,KBNUL,KBNUL,KBSYM,051h, KBNUL,KBNUL,KBSYM,050h, KBNUL,KBNUL,KBSYM,050h, KBNUL,KBNUL
                    db      KBCAP,050h, KBNUL,KBNUL,KBCAP,KBSYM,050h, KBNUL,KBCAP,KBSYM,050h, KBNUL,KBCAP,KBSYM,050h, KBNUL
                    ; "-"
                    db      KBSYM,077h, KBNUL,KBNUL,KBSYM,050h, KBNUL,KBNUL,KBSYM,050h, KBNUL,KBNUL,KBSYM,050h, KBNUL,KBNUL
                    db      KBSYM,050h, KBNUL,KBCAP,KBSYM,050h, KBNUL,KBCAP,KBSYM,050h, KBNUL,KBCAP,KBSYM,050h, KBNUL,KBCAP
                    ; "="
                    db      KBSYM,071h, KBNUL,KBNUL,KBSYM,073h, KBNUL,KBNUL,KBSYM,073h, KBNUL,KBNUL,KBSYM,073h, KBNUL,KBNUL
                    db      KBSYM,073h, KBNUL,KBCAP,KBSYM,073h, KBNUL,KBCAP,KBSYM,073h, KBNUL,KBCAP,KBSYM,073h, KBNUL,KBCAP
                    ; Backspace
                    db      KBCAP,050h, KBNUL,KBNUL,KBCAP,KBSYM,050h, KBNUL,KBCAP,KBSYM,050h, KBNUL,KBCAP,KBSYM,050h, KBNUL
                    db      KBCAP,050h, KBNUL,KBNUL,KBCAP,KBSYM,050h, KBNUL,KBCAP,KBSYM,050h, KBNUL,KBCAP,KBSYM,050h, KBNUL
                    ; Tab
                    db      KBCAP,KBSYM,KBNUL,KBNUL,KBCAP,KBSYM,KBNUL,KBNUL,KBCAP,KBSYM,KBNUL,KBNUL,KBCAP,KBSYM,KBNUL,KBNUL
                    db      KBCAP,KBSYM,KBNUL,KBNUL,KBCAP,KBSYM,KBNUL,KBNUL,KBCAP,KBSYM,KBNUL,KBNUL,KBCAP,KBSYM,KBNUL,KBNUL
                    ; "Q"
                    db      030h, KBNUL,KBNUL,KBNUL,KBSYM,030h, KBNUL,KBNUL,KBSYM,030h, KBNUL,KBNUL,KBSYM,030h, KBNUL,KBNUL
                    db      KBCAP,030h, KBNUL,KBNUL,KBCAP,KBSYM,030h, KBNUL,KBCAP,KBSYM,030h, KBNUL,KBCAP,KBSYM,030h, KBNUL
                    ; "W"
                    db      031h, KBNUL,KBNUL,KBNUL,KBSYM,031h, KBNUL,KBNUL,KBSYM,031h, KBNUL,KBNUL,KBSYM,031h, KBNUL,KBNUL
                    db      KBCAP,031h, KBNUL,KBNUL,KBCAP,KBSYM,031h, KBNUL,KBCAP,KBSYM,031h, KBNUL,KBCAP,KBSYM,031h, KBNUL
                    ; "E"
                    db      033h, KBNUL,KBNUL,KBNUL,KBSYM,033h, KBNUL,KBNUL,KBSYM,033h, KBNUL,KBNUL,KBSYM,033h, KBNUL,KBNUL
                    db      KBCAP,033h, KBNUL,KBNUL,KBCAP,KBSYM,033h, KBNUL,KBCAP,KBSYM,033h, KBNUL,KBCAP,KBSYM,033h, KBNUL
                    ; "R"
                    db      037h, KBNUL,KBNUL,KBNUL,KBSYM,037h, KBNUL,KBNUL,KBSYM,037h, KBNUL,KBNUL,KBSYM,037h, KBNUL,KBNUL
                    db      KBCAP,037h, KBNUL,KBNUL,KBCAP,KBSYM,037h, KBNUL,KBCAP,KBSYM,037h, KBNUL,KBCAP,KBSYM,037h, KBNUL
                    ; "T"
                    db      03Fh, KBNUL,KBNUL,KBNUL,KBSYM,03Fh, KBNUL,KBNUL,KBSYM,03Fh, KBNUL,KBNUL,KBSYM,03Fh, KBNUL,KBNUL
                    db      KBCAP,03Fh, KBNUL,KBNUL,KBCAP,KBSYM,03Fh, KBNUL,KBCAP,KBSYM,03Fh, KBNUL,KBCAP,KBSYM,03Fh, KBNUL
                    ; "Y"
                    db      06Fh, KBNUL,KBNUL,KBNUL,KBSYM,06Fh, KBNUL,KBNUL,KBSYM,06Fh, KBNUL,KBNUL,KBSYM,06Fh, KBNUL,KBNUL
                    db      KBCAP,06Fh, KBNUL,KBNUL,KBCAP,KBSYM,06Fh, KBNUL,KBCAP,KBSYM,06Fh, KBNUL,KBCAP,KBSYM,06Fh, KBNUL
                    ; "U"
                    db      067h, KBNUL,KBNUL,KBNUL,KBSYM,067h, KBNUL,KBNUL,KBSYM,067h, KBNUL,KBNUL,KBSYM,067h, KBNUL,KBNUL
                    db      KBCAP,067h, KBNUL,KBNUL,KBCAP,KBSYM,067h, KBNUL,KBCAP,KBSYM,067h, KBNUL,KBCAP,KBSYM,067h, KBNUL
                    ; "I"
                    db      063h, KBNUL,KBNUL,KBNUL,KBSYM,063h, KBNUL,KBNUL,KBSYM,063h, KBNUL,KBNUL,KBSYM,063h, KBNUL,KBNUL
                    db      KBCAP,063h, KBNUL,KBNUL,KBCAP,KBSYM,063h, KBNUL,KBCAP,KBSYM,063h, KBNUL,KBCAP,KBSYM,063h, KBNUL
                    ; "O"
                    db      061h, KBNUL,KBNUL,KBNUL,KBSYM,061h, KBNUL,KBNUL,KBSYM,061h, KBNUL,KBNUL,KBSYM,061h, KBNUL,KBNUL
                    db      KBCAP,061h, KBNUL,KBNUL,KBCAP,KBSYM,061h, KBNUL,KBCAP,KBSYM,061h, KBNUL,KBCAP,KBSYM,061h, KBNUL
                    ; "P"
                    db      060h, KBNUL,KBNUL,KBNUL,KBSYM,060h, KBNUL,KBNUL,KBSYM,060h, KBNUL,KBNUL,KBSYM,060h, KBNUL,KBNUL
                    db      KBCAP,060h, KBNUL,KBNUL,KBCAP,KBSYM,060h, KBNUL,KBCAP,KBSYM,060h, KBNUL,KBCAP,KBSYM,060h, KBNUL
                    ; "["
                    db      KBSYM,053h, KBNUL,KBNUL,KBSYM,053h, KBNUL,KBNUL,KBSYM,053h, KBNUL,KBNUL,KBSYM,053h, KBNUL,KBNUL
                    db      KBSYM,053h, KBNUL,KBNUL,KBSYM,053h, KBNUL,KBNUL,KBSYM,053h, KBNUL,KBNUL,KBSYM,053h, KBNUL,KBNUL
                    ; "]"
                    db      KBSYM,051h, KBNUL,KBNUL,KBSYM,051h, KBNUL,KBNUL,KBSYM,051h, KBNUL,KBNUL,KBSYM,051h, KBNUL,KBNUL
                    db      KBSYM,051h, KBNUL,KBNUL,KBSYM,051h, KBNUL,KBNUL,KBSYM,051h, KBNUL,KBNUL,KBSYM,051h, KBNUL,KBNUL
                    ; Enter
                    db      070h, KBNUL,KBNUL,KBNUL,KBSYM,070h, KBNUL,KBNUL,KBSYM,070h, KBNUL,KBNUL,KBSYM,070h, KBNUL,KBNUL
                    db      KBCAP,070h, KBNUL,KBNUL,KBCAP,KBSYM,070h, KBNUL,KBCAP,KBSYM,070h, KBNUL,KBCAP,KBSYM,070h, KBNUL
                    ; Ctrl (L)
                    db      KBSYM,0D7h, KBNUL,KBNUL,KBSYM,0D7h, KBNUL,KBNUL,KBSYM,0D7h, KBNUL,KBNUL,KBSYM,0D7h, KBNUL,KBNUL
                    db      KBCAP,KBSYM,0D7h, KBNUL,KBCAP,KBSYM,0D7h, KBNUL,KBCAP,KBSYM,0D7h, KBNUL,KBCAP,KBSYM,0D7h, KBNUL
                    ; "A"
                    db      020h, KBNUL,KBNUL,KBNUL,KBSYM,020h, KBNUL,KBNUL,KBSYM,020h, KBNUL,KBNUL,KBSYM,020h, KBNUL,KBNUL
                    db      KBCAP,020h, KBNUL,KBNUL,KBCAP,KBSYM,020h, KBNUL,KBCAP,KBSYM,020h, KBNUL,KBCAP,KBSYM,020h, KBNUL
                    ; "S"
                    db      021h, KBNUL,KBNUL,KBNUL,KBSYM,021h, KBNUL,KBNUL,KBSYM,021h, KBNUL,KBNUL,KBSYM,021h, KBNUL,KBNUL
                    db      KBCAP,021h, KBNUL,KBNUL,KBCAP,KBSYM,021h, KBNUL,KBCAP,KBSYM,021h, KBNUL,KBCAP,KBSYM,021h, KBNUL
                    ; "D"
                    db      023h, KBNUL,KBNUL,KBNUL,KBSYM,023h, KBNUL,KBNUL,KBSYM,023h, KBNUL,KBNUL,KBSYM,023h, KBNUL,KBNUL
                    db      KBCAP,023h, KBNUL,KBNUL,KBCAP,KBSYM,023h, KBNUL,KBCAP,KBSYM,023h, KBNUL,KBCAP,KBSYM,023h, KBNUL
                    ; "F"
                    db      027h, KBNUL,KBNUL,KBNUL,KBSYM,027h, KBNUL,KBNUL,KBSYM,027h, KBNUL,KBNUL,KBSYM,027h, KBNUL,KBNUL
                    db      KBCAP,027h, KBNUL,KBNUL,KBCAP,KBSYM,027h, KBNUL,KBCAP,KBSYM,027h, KBNUL,KBCAP,KBSYM,027h, KBNUL
                    ; "G"
                    db      02Fh, KBNUL,KBNUL,KBNUL,KBSYM,02Fh, KBNUL,KBNUL,KBSYM,02Fh, KBNUL,KBNUL,KBSYM,02Fh, KBNUL,KBNUL
                    db      KBCAP,02Fh, KBNUL,KBNUL,KBCAP,KBSYM,02Fh, KBNUL,KBCAP,KBSYM,02Fh, KBNUL,KBCAP,KBSYM,02Fh, KBNUL
                    ; "H"
                    db      07Fh, KBNUL,KBNUL,KBNUL,KBSYM,07Fh, KBNUL,KBNUL,KBSYM,07Fh, KBNUL,KBNUL,KBSYM,07Fh, KBNUL,KBNUL
                    db      KBCAP,07Fh, KBNUL,KBNUL,KBCAP,KBSYM,07Fh, KBNUL,KBCAP,KBSYM,07Fh, KBNUL,KBCAP,KBSYM,07Fh, KBNUL
                    ; "J"
                    db      077h, KBNUL,KBNUL,KBNUL,KBSYM,077h, KBNUL,KBNUL,KBSYM,077h, KBNUL,KBNUL,KBSYM,077h, KBNUL,KBNUL
                    db      KBCAP,077h, KBNUL,KBNUL,KBCAP,KBSYM,077h, KBNUL,KBCAP,KBSYM,077h, KBNUL,KBCAP,KBSYM,077h, KBNUL
                    ; "K"
                    db      073h, KBNUL,KBNUL,KBNUL,KBSYM,073h, KBNUL,KBNUL,KBSYM,073h, KBNUL,KBNUL,KBSYM,073h, KBNUL,KBNUL
                    db      KBCAP,073h, KBNUL,KBNUL,KBCAP,KBSYM,073h, KBNUL,KBCAP,KBSYM,073h, KBNUL,KBCAP,KBSYM,073h, KBNUL
                    ; "L"
                    db      071h, KBNUL,KBNUL,KBNUL,KBSYM,071h, KBNUL,KBNUL,KBSYM,071h, KBNUL,KBNUL,KBSYM,071h, KBNUL,KBNUL
                    db      KBCAP,071h, KBNUL,KBNUL,KBCAP,KBSYM,071h, KBNUL,KBCAP,KBSYM,071h, KBNUL,KBCAP,KBSYM,071h, KBNUL
                    ; ";"
                    db      KBSYM,061h, KBNUL,KBNUL,KBSYM,011h, KBNUL,KBNUL,KBSYM,061h, KBNUL,KBNUL,KBSYM,061h, KBNUL,KBNUL
                    db      KBSYM,011h, KBNUL,KBCAP,KBSYM,011h, KBNUL,KBCAP,KBSYM,011h, KBNUL,KBCAP,KBSYM,011h, KBNUL,KBCAP
                    ; "'"
                    db      KBSYM,057h, KBNUL,KBNUL,KBSYM,060h, KBNUL,KBNUL,KBSYM,057h, KBNUL,KBNUL,KBSYM,057h, KBNUL,KBNUL
                    db      KBSYM,060h, KBNUL,KBCAP,KBSYM,060h, KBNUL,KBCAP,KBSYM,060h, KBNUL,KBCAP,KBSYM,060h, KBNUL,KBCAP
                    ; "`"
                    db      KBCAP,040h, KBNUL,KBNUL,KBCAP,KBSYM,040h, KBNUL,KBCAP,KBSYM,040h, KBNUL,KBCAP,KBSYM,040h, KBNUL
                    db      KBCAP,040h, KBNUL,KBNUL,KBCAP,KBSYM,040h, KBNUL,KBCAP,KBSYM,040h, KBNUL,KBCAP,KBSYM,040h, KBNUL
                    ; Shift (L)
                    db      KBCAP,0DFh, KBNUL,KBNUL,KBCAP,KBSYM,0DFh, KBNUL,KBCAP,KBSYM,0DFh, KBNUL,KBCAP,KBSYM,0DFh, KBNUL
                    db      KBCAP,0DFh, KBNUL,KBNUL,KBCAP,KBSYM,0DFh, KBNUL,KBCAP,KBSYM,0DFh, KBNUL,KBCAP,KBSYM,0DFh, KBNUL
                    ; "\"
                    db      KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL
                    db      KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL
                    ; "Z"
                    db      011h, KBNUL,KBNUL,KBNUL,KBSYM,011h, KBNUL,KBNUL,KBSYM,011h, KBNUL,KBNUL,KBSYM,011h, KBNUL,KBNUL
                    db      KBCAP,011h, KBNUL,KBNUL,KBCAP,KBSYM,011h, KBNUL,KBCAP,KBSYM,011h, KBNUL,KBCAP,KBSYM,011h, KBNUL
                    ; "X"
                    db      013h, KBNUL,KBNUL,KBNUL,KBSYM,013h, KBNUL,KBNUL,KBSYM,013h, KBNUL,KBNUL,KBSYM,013h, KBNUL,KBNUL
                    db      KBCAP,013h, KBNUL,KBNUL,KBCAP,KBSYM,013h, KBNUL,KBCAP,KBSYM,013h, KBNUL,KBCAP,KBSYM,011h, KBNUL
                    ; "C"
                    db      017h, KBNUL,KBNUL,KBNUL,KBSYM,017h, KBNUL,KBNUL,KBSYM,017h, KBNUL,KBNUL,KBSYM,017h, KBNUL,KBNUL
                    db      KBCAP,017h, KBNUL,KBNUL,KBCAP,KBSYM,017h, KBNUL,KBCAP,KBSYM,017h, KBNUL,KBCAP,KBSYM,017h, KBNUL
                    ; "V"
                    db      01Fh, KBNUL,KBNUL,KBNUL,KBSYM,01Fh, KBNUL,KBNUL,KBSYM,01Fh, KBNUL,KBNUL,KBSYM,01Fh, KBNUL,KBNUL
                    db      KBCAP,01Fh, KBNUL,KBNUL,KBCAP,KBSYM,01Fh, KBNUL,KBCAP,KBSYM,01Fh, KBNUL,KBCAP,KBSYM,01Fh, KBNUL
                    ; "B"
                    db      08Fh, KBNUL,KBNUL,KBNUL,KBSYM,08Fh, KBNUL,KBNUL,KBSYM,08Fh, KBNUL,KBNUL,KBSYM,08Fh, KBNUL,KBNUL
                    db      KBCAP,08Fh, KBNUL,KBNUL,KBCAP,KBSYM,08Fh, KBNUL,KBCAP,KBSYM,08Fh, KBNUL,KBCAP,KBSYM,08Fh, KBNUL
                    ; "N"
                    db      087h, KBNUL,KBNUL,KBNUL,KBSYM,087h, KBNUL,KBNUL,KBSYM,087h, KBNUL,KBNUL,KBSYM,087h, KBNUL,KBNUL
                    db      KBCAP,087h, KBNUL,KBNUL,KBCAP,KBSYM,087h, KBNUL,KBCAP,KBSYM,087h, KBNUL,KBCAP,KBSYM,087h, KBNUL
                    ; "M"
                    db      083h, KBNUL,KBNUL,KBNUL,KBSYM,083h, KBNUL,KBNUL,KBSYM,083h, KBNUL,KBNUL,KBSYM,083h, KBNUL,KBNUL
                    db      KBCAP,083h, KBNUL,KBNUL,KBCAP,KBSYM,083h, KBNUL,KBCAP,KBSYM,083h, KBNUL,KBCAP,KBSYM,083h, KBNUL
                    ; ","
                    db      KBSYM,087h, KBNUL,KBNUL,KBSYM,037h, KBNUL,KBNUL,KBSYM,087h, KBNUL,KBNUL,KBSYM,087h, KBNUL,KBNUL
                    db      KBSYM,037h, KBNUL,KBCAP,KBSYM,037h, KBNUL,KBCAP,KBSYM,037h, KBNUL,KBCAP,KBSYM,037h, KBNUL,KBCAP
                    ; "."
                    db      KBSYM,083h, KBNUL,KBNUL,KBSYM,03Fh, KBNUL,KBNUL,KBSYM,083h, KBNUL,KBNUL,KBSYM,083h, KBNUL,KBNUL
                    db      KBSYM,03Fh, KBNUL,KBCAP,KBSYM,03Fh, KBNUL,KBCAP,KBSYM,03Fh, KBNUL,KBCAP,KBSYM,03Fh, KBNUL,KBCAP
                    ; "/"
                    db      KBSYM,01Fh, KBNUL,KBNUL,KBSYM,017h, KBNUL,KBNUL,KBSYM,01Fh, KBNUL,KBNUL,KBSYM,01Fh, KBNUL,KBNUL
                    db      KBSYM,017h, KBNUL,KBCAP,KBSYM,017h, KBNUL,KBCAP,KBSYM,017h, KBNUL,KBCAP,KBSYM,017h, KBNUL,KBCAP
                    ; Shift (R)
                    db      KBCAP,0EFh, KBNUL,KBNUL,KBCAP,KBSYM,0EFh, KBNUL,KBCAP,KBSYM,0EFh, KBNUL,KBCAP,KBSYM,0EFh, KBNUL
                    db      KBCAP,0EFh, KBNUL,KBNUL,KBCAP,KBSYM,0EFh, KBNUL,KBCAP,KBSYM,0EFh, KBNUL,KBCAP,KBSYM,0EFh, KBNUL
                    ; "*" keypad
                    db      KBSYM,08Fh, KBNUL,KBNUL,KBSYM,08Fh, KBNUL,KBNUL,KBSYM,08Fh, KBNUL,KBNUL,KBSYM,08Fh, KBNUL,KBNUL
                    db      KBCAP,KBSYM,08Fh, KBNUL,KBCAP,KBSYM,08Fh, KBNUL,KBCAP,KBSYM,08Fh, KBNUL,KBCAP,KBSYM,08Fh, KBNUL
                    ; Alt (L)
                    db      KBSYM,0D3h, KBNUL,KBNUL,KBSYM,0D3h, KBNUL,KBNUL,KBSYM,0D3h, KBNUL,KBNUL,KBSYM,0D3h, KBNUL,KBNUL
                    db      KBCAP,KBSYM,0D3h, KBNUL,KBCAP,KBSYM,0D3h, KBNUL,KBCAP,KBSYM,0D3h, KBNUL,KBCAP,KBSYM,0D3h, KBNUL
                    ; Space
                    db      080h, KBNUL,KBNUL,KBNUL,KBSYM,080h, KBNUL,KBNUL,KBSYM,080h, KBNUL,KBNUL,KBSYM,080h, KBNUL,KBNUL
                    db      KBCAP,080h, KBNUL,KBNUL,KBCAP,KBSYM,080h, KBNUL,KBCAP,KBSYM,080h, KBNUL,KBCAP,KBSYM,080h, KBNUL
                    ; Caps Lock
                    db      KBCAP,041h, KBNUL,KBNUL,KBCAP,KBSYM,041h, KBNUL,KBCAP,KBSYM,041h, KBNUL,KBCAP,KBSYM,041h, KBNUL
                    db      KBCAP,041h, KBNUL,KBNUL,KBCAP,KBSYM,041h, KBNUL,KBCAP,KBSYM,041h, KBNUL,KBCAP,KBSYM,041h, KBNUL
                    ; F1
                    db      0A0h, KBNUL,KBNUL,KBNUL,0A0h, KBNUL,KBNUL,KBNUL,0A0h, KBNUL,KBNUL,KBNUL,0A0h, KBNUL,KBNUL,KBNUL
                    db      0A0h, KBNUL,KBNUL,KBNUL,0A0h, KBNUL,KBNUL,KBNUL,0A0h, KBNUL,KBNUL,KBNUL,0A0h, KBNUL,KBNUL,KBNUL
                    ; F2
                    db      0A1h, KBNUL,KBNUL,KBNUL,0A1h, KBNUL,KBNUL,KBNUL,0A1h, KBNUL,KBNUL,KBNUL,0A1h, KBNUL,KBNUL,KBNUL
                    db      0A1h, KBNUL,KBNUL,KBNUL,0A1h, KBNUL,KBNUL,KBNUL,0A1h, KBNUL,KBNUL,KBNUL,0A1h, KBNUL,KBNUL,KBNUL
                    ; F3
                    db      0A3h, KBNUL,KBNUL,KBNUL,0A3h, KBNUL,KBNUL,KBNUL,0A3h, KBNUL,KBNUL,KBNUL,0A3h, KBNUL,KBNUL,KBNUL
                    db      0A3h, KBNUL,KBNUL,KBNUL,0A3h, KBNUL,KBNUL,KBNUL,0A3h, KBNUL,KBNUL,KBNUL,0A3h, KBNUL,KBNUL,KBNUL
                    ; F4
                    db      0A7h, KBNUL,KBNUL,KBNUL,0A7h, KBNUL,KBNUL,KBNUL,0A7h, KBNUL,KBNUL,KBNUL,0A7h, KBNUL,KBNUL,KBNUL
                    db      0A7h, KBNUL,KBNUL,KBNUL,0A7h, KBNUL,KBNUL,KBNUL,0A7h, KBNUL,KBNUL,KBNUL,0A7h, KBNUL,KBNUL,KBNUL
                    ; F5
                    db      0AFh, KBNUL,KBNUL,KBNUL,0AFh, KBNUL,KBNUL,KBNUL,0AFh, KBNUL,KBNUL,KBNUL,0AFh, KBNUL,KBNUL,KBNUL
                    db      0AFh, KBNUL,KBNUL,KBNUL,0AFh, KBNUL,KBNUL,KBNUL,0AFh, KBNUL,KBNUL,KBNUL,0AFh, KBNUL,KBNUL,KBNUL
                    ; F6
                    db      0B0h, KBNUL,KBNUL,KBNUL,0B0h, KBNUL,KBNUL,KBNUL,0B0h, KBNUL,KBNUL,KBNUL,0B0h, KBNUL,KBNUL,KBNUL
                    db      0B0h, KBNUL,KBNUL,KBNUL,0B0h, KBNUL,KBNUL,KBNUL,0B0h, KBNUL,KBNUL,KBNUL,0B0h, KBNUL,KBNUL,KBNUL
                    ; F7
                    db      0B1h, KBNUL,KBNUL,KBNUL,0B1h, KBNUL,KBNUL,KBNUL,0B1h, KBNUL,KBNUL,KBNUL,0B1h, KBNUL,KBNUL,KBNUL
                    db      0B1h, KBNUL,KBNUL,KBNUL,0B1h, KBNUL,KBNUL,KBNUL,0B1h, KBNUL,KBNUL,KBNUL,0B1h, KBNUL,KBNUL,KBNUL
                    ; F8
                    db      0B3h, KBNUL,KBNUL,KBNUL,0B3h, KBNUL,KBNUL,KBNUL,0B3h, KBNUL,KBNUL,KBNUL,0B3h, KBNUL,KBNUL,KBNUL
                    db      0B3h, KBNUL,KBNUL,KBNUL,0B3h, KBNUL,KBNUL,KBNUL,0B3h, KBNUL,KBNUL,KBNUL,0B3h, KBNUL,KBNUL,KBNUL
                    ; F9
                    db      0B7h, KBNUL,KBNUL,KBNUL,0B7h, KBNUL,KBNUL,KBNUL,0B7h, KBNUL,KBNUL,KBNUL,0B7h, KBNUL,KBNUL,KBNUL
                    db      0B7h, KBNUL,KBNUL,KBNUL,0B7h, KBNUL,KBNUL,KBNUL,0B7h, KBNUL,KBNUL,KBNUL,0B7h, KBNUL,KBNUL,KBNUL
                    ; F10
                    db      0BFh, KBNUL,KBNUL,KBNUL,0BFh, KBNUL,KBNUL,KBNUL,0BFh, KBNUL,KBNUL,KBNUL,0BFh, KBNUL,KBNUL,KBNUL
                    db      0BFh, KBNUL,KBNUL,KBNUL,0BFh, KBNUL,KBNUL,KBNUL,0BFh, KBNUL,KBNUL,KBNUL,0BFh, KBNUL,KBNUL,KBNUL
                    ; Num Lock
                    db      09Fh, KBNUL,KBNUL,KBNUL,09Fh, KBNUL,KBNUL,KBNUL,09Fh, KBNUL,KBNUL,KBNUL,09Fh, KBNUL,KBNUL,KBNUL
                    db      09Fh, KBNUL,KBNUL,KBNUL,09Fh, KBNUL,KBNUL,KBNUL,09Fh, KBNUL,KBNUL,KBNUL,09Fh, KBNUL,KBNUL,KBNUL
                    ; Scroll Lock
                    db      093h, KBNUL,KBNUL,KBNUL,093h, KBNUL,KBNUL,KBNUL,093h, KBNUL,KBNUL,KBNUL,093h, KBNUL,KBNUL,KBNUL
                    db      093h, KBNUL,KBNUL,KBNUL,093h, KBNUL,KBNUL,KBNUL,093h, KBNUL,KBNUL,KBNUL,093h, KBNUL,KBNUL,KBNUL
                    ; Home [7]
                    db      009h, KBNUL,KBNUL,KBNUL,KBSYM,009h, KBNUL,KBNUL,KBSYM,009h, KBNUL,KBNUL,KBSYM,009h, KBNUL,KBNUL
                    db      KBCAP,009h, KBNUL,KBNUL,KBCAP,KBSYM,009h, KBNUL,KBCAP,KBSYM,009h, KBNUL,KBCAP,KBSYM,009h, KBNUL
                    ; ^^ [8]
                    db      007h, KBNUL,KBNUL,KBNUL,KBSYM,007h, KBNUL,KBNUL,KBSYM,007h, KBNUL,KBNUL,KBSYM,007h, KBNUL,KBNUL
                    db      KBCAP,007h, KBNUL,KBNUL,KBCAP,KBSYM,007h, KBNUL,KBCAP,KBSYM,007h, KBNUL,KBCAP,KBSYM,007h, KBNUL
                    ; PgUp [9]
                    db      008h, KBNUL,KBNUL,KBNUL,KBSYM,008h, KBNUL,KBNUL,KBSYM,008h, KBNUL,KBNUL,KBSYM,008h, KBNUL,KBNUL
                    db      KBCAP,008h, KBNUL,KBNUL,KBCAP,KBSYM,008h, KBNUL,KBCAP,KBSYM,008h, KBNUL,KBCAP,KBSYM,008h, KBNUL
                    ; "-" keypad
                    db      KBSYM,077h, KBNUL,KBNUL,KBSYM,077h, KBNUL,KBNUL,KBSYM,077h, KBNUL,KBNUL,KBSYM,077h, KBNUL,KBNUL
                    db      KBCAP,KBSYM,077h, KBNUL,KBCAP,KBSYM,077h, KBNUL,KBCAP,KBSYM,077h, KBNUL,KBCAP,KBSYM,077h, KBNUL
                    ; << [4]
                    db      001h, KBNUL,KBNUL,KBNUL,KBSYM,001h, KBNUL,KBNUL,KBSYM,001h, KBNUL,KBNUL,KBSYM,001h, KBNUL,KBNUL
                    db      KBCAP,001h, KBNUL,KBNUL,KBCAP,KBSYM,001h, KBNUL,KBCAP,KBSYM,001h, KBNUL,KBCAP,KBSYM,001h, KBNUL
                    ; [5]
                    db      003h, KBNUL,KBNUL,KBNUL,KBSYM,003h, KBNUL,KBNUL,KBSYM,003h, KBNUL,KBNUL,KBSYM,003h, KBNUL,KBNUL
                    db      KBCAP,003h, KBNUL,KBNUL,KBCAP,KBSYM,003h, KBNUL,KBCAP,KBSYM,003h, KBNUL,KBCAP,KBSYM,003h, KBNUL
                    ; >> [6]
                    db      000h, KBNUL,KBNUL,KBNUL,KBSYM,000h, KBNUL,KBNUL,KBSYM,000h, KBNUL,KBNUL,KBSYM,000h, KBNUL,KBNUL
                    db      KBCAP,000h, KBNUL,KBNUL,KBCAP,KBSYM,000h, KBNUL,KBCAP,KBSYM,000h, KBNUL,KBCAP,KBSYM,000h, KBNUL
                    ; "+" keypad
                    db      KBSYM,073h, KBNUL,KBNUL,KBSYM,073h, KBNUL,KBNUL,KBSYM,073h, KBNUL,KBNUL,KBSYM,073h, KBNUL,KBNUL
                    db      KBCAP,KBSYM,073h, KBNUL,KBCAP,KBSYM,073h, KBNUL,KBCAP,KBSYM,073h, KBNUL,KBCAP,KBSYM,073h, KBNUL
                    ; End [1]
                    db      005h, KBNUL,KBNUL,KBNUL,KBSYM,005h, KBNUL,KBNUL,KBSYM,005h, KBNUL,KBNUL,KBSYM,005h, KBNUL,KBNUL
                    db      KBCAP,005h, KBNUL,KBNUL,KBCAP,KBSYM,005h, KBNUL,KBCAP,KBSYM,005h, KBNUL,KBCAP,KBSYM,005h, KBNUL
                    ; vv [2]
                    db      003h, KBNUL,KBNUL,KBNUL,KBSYM,003h, KBNUL,KBNUL,KBSYM,003h, KBNUL,KBNUL,KBSYM,003h, KBNUL,KBNUL
                    db      KBCAP,003h, KBNUL,KBNUL,KBCAP,KBSYM,003h, KBNUL,KBCAP,KBSYM,003h, KBNUL,KBCAP,KBSYM,003h, KBNUL
                    ; PgDn [3]
                    db      004h, KBNUL,KBNUL,KBNUL,KBSYM,004h, KBNUL,KBNUL,KBSYM,004h, KBNUL,KBNUL,KBSYM,004h, KBNUL,KBNUL
                    db      KBCAP,004h, KBNUL,KBNUL,KBCAP,KBSYM,004h, KBNUL,KBCAP,KBSYM,004h, KBNUL,KBCAP,KBSYM,004h, KBNUL
                    ; Ins [0]
                    db      00Fh, KBNUL,KBNUL,KBNUL,KBSYM,00Fh, KBNUL,KBNUL,KBSYM,00Fh, KBNUL,KBNUL,KBSYM,00Fh, KBNUL,KBNUL
                    db      KBCAP,00Fh, KBNUL,KBNUL,KBCAP,KBSYM,00Fh, KBNUL,KBCAP,KBSYM,00Fh, KBNUL,KBCAP,KBSYM,00Fh, KBNUL
                    ; Del [.]
                    db      00Fh, KBNUL,KBNUL,KBNUL,KBSYM,00Fh, KBNUL,KBNUL,KBSYM,00Fh, KBNUL,KBNUL,KBSYM,00Fh, KBNUL,KBNUL
                    db      KBCAP,00Fh, KBNUL,KBNUL,KBCAP,KBSYM,00Fh, KBNUL,KBCAP,KBSYM,00Fh, KBNUL,KBCAP,KBSYM,00Fh, KBNUL
                    ; Print Screen
                    db      091h, KBNUL,KBNUL,KBNUL,091h, KBNUL,KBNUL,KBNUL,091h, KBNUL,KBNUL,KBNUL,091h, KBNUL,KBNUL,KBNUL
                    db      091h, KBNUL,KBNUL,KBNUL,091h, KBNUL,KBNUL,KBNUL,091h, KBNUL,KBNUL,KBNUL,091h, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; F11
                    db      0C0h, KBNUL,KBNUL,KBNUL,0C0h, KBNUL,KBNUL,KBNUL,0C0h, KBNUL,KBNUL,KBNUL,0C0h, KBNUL,KBNUL,KBNUL
                    db      0C0h, KBNUL,KBNUL,KBNUL,0C0h, KBNUL,KBNUL,KBNUL,0C0h, KBNUL,KBNUL,KBNUL,0C0h, KBNUL,KBNUL,KBNUL
                    ; F12
                    db      0C1h, KBNUL,KBNUL,KBNUL,0C1h, KBNUL,KBNUL,KBNUL,0C1h, KBNUL,KBNUL,KBNUL,0C1h, KBNUL,KBNUL,KBNUL
                    db      0C1h, KBNUL,KBNUL,KBNUL,0C1h, KBNUL,KBNUL,KBNUL,0C1h, KBNUL,KBNUL,KBNUL,0C1h, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; #E0 prefix
                    db      0D0h, KBNUL,KBNUL,001h, 0D0h, KBNUL,KBNUL,001h, 0D0h, KBNUL,KBNUL,001h, 0D0h, KBNUL,KBNUL,001h
                    db      0D0h, KBNUL,KBNUL,001h, 0D0h, KBNUL,KBNUL,001h, 0D0h, KBNUL,KBNUL,001h, 0D0h, KBNUL,KBNUL,001h
                    ; #E1 prefix
                    db      0E0h, 097h, KBNUL,003h, 0E0h, 097h, KBNUL,003h, 0E0h, 097h, KBNUL,003h, 0E0h, 097h, KBNUL,003h
                    db      0E0h, 097h, KBNUL,003h, 0E0h, 097h, KBNUL,003h, 0E0h, 097h, KBNUL,003h, 0E0h, 097h, KBNUL,003h
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; #F0 - release prefix
                    db      0D1h, KBNUL,KBNUL,001h, 0D1h, KBNUL,KBNUL,001h, 0D1h, KBNUL,KBNUL,001h, 0D1h, KBNUL,KBNUL,001h
                    db      0D1h, KBNUL,KBNUL,001h, 0D1h, KBNUL,KBNUL,001h, 0D1h, KBNUL,KBNUL,001h, 0D1h, KBNUL,KBNUL,001h
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; #FA - command ACK
                    db      KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL
                    db      KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; #FE - command aborted
                    db      KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL
                    db      KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL
                    ; KB error
                    db      0C3h, KBNUL,KBNUL,KBNUL,0C3h, KBNUL,KBNUL,KBNUL,0C3h, KBNUL,KBNUL,KBNUL,0C3h, KBNUL,KBNUL,KBNUL
                    db      0C3h, KBNUL,KBNUL,KBNUL,0C3h, KBNUL,KBNUL,KBNUL,0C3h, KBNUL,KBNUL,KBNUL,0C3h, KBNUL,KBNUL,KBNUL

ScanCodeTabX        label   byte
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Enter keypad
                    db      070h, KBNUL,KBNUL,KBNUL,KBSYM,070h, KBNUL,KBNUL,KBSYM,070h, KBNUL,KBNUL,KBSYM,070h, KBNUL,KBNUL
                    db      KBCAP,070h, KBNUL,KBNUL,KBCAP,KBSYM,070h, KBNUL,KBCAP,KBSYM,070h, KBNUL,KBCAP,KBSYM,070h, KBNUL
                    ; Ctrl (R)
                    db      KBSYM,0E7h, KBNUL,KBNUL,KBSYM,0E7h, KBNUL,KBNUL,KBSYM,0E7h, KBNUL,KBNUL,KBSYM,0E7h, KBNUL,KBNUL
                    db      KBCAP,KBSYM,0E7h, KBNUL,KBCAP,KBSYM,0E7h, KBNUL,KBCAP,KBSYM,0E7h, KBNUL,KBCAP,KBSYM,0E7h, KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; &Shift(L)
                    db      KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL
                    db      KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; "/" keypad
                    db      KBSYM,01Fh, KBNUL,KBNUL,KBSYM,01Fh, KBNUL,KBNUL,KBSYM,01Fh, KBNUL,KBNUL,KBSYM,01Fh, KBNUL,KBNUL
                    db      KBCAP,KBSYM,01Fh, KBNUL,KBCAP,KBSYM,01Fh, KBNUL,KBCAP,KBSYM,01Fh, KBNUL,KBCAP,KBSYM,01Fh, KBNUL
                    ; &Shift(R)
                    db      KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL
                    db      KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL
                    ; Print Screen
                    db      091h, KBNUL,KBNUL,KBNUL,091h, KBNUL,KBNUL,KBNUL,091h, KBNUL,KBNUL,KBNUL,091h, KBNUL,KBNUL,KBNUL
                    db      091h, KBNUL,KBNUL,KBNUL,091h, KBNUL,KBNUL,KBNUL,091h, KBNUL,KBNUL,KBNUL,091h, KBNUL,KBNUL,KBNUL
                    ; Alt (R)
                    db      KBSYM,0E3h, KBNUL,KBNUL,KBSYM,0E3h, KBNUL,KBNUL,KBSYM,0E3h, KBNUL,KBNUL,KBSYM,0E3h, KBNUL,KBNUL
                    db      KBCAP,KBSYM,0E3h, KBNUL,KBCAP,KBSYM,0E3h, KBNUL,KBCAP,KBSYM,0E3h, KBNUL,KBCAP,KBSYM,0E3h, KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Ctrl+Pause
                    db      0E0h, 097h, KBNUL,003h, 0E0h, 097h, KBNUL,003h, 0E0h, 097h, KBNUL,003h, 0E0h, 097h, KBNUL,003h
                    db      0E0h, 097h, KBNUL,003h, 0E0h, 097h, KBNUL,003h, 0E0h, 097h, KBNUL,003h, 0E0h, 097h, KBNUL,003h
                    ; Home
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; 
                    db      KBCAP,057h, KBNUL,KBNUL,KBCAP,KBSYM,057h, KBNUL,KBCAP,KBSYM,057h, KBNUL,KBCAP,KBSYM,057h, KBNUL
                    db      KBCAP,057h, KBNUL,KBNUL,KBCAP,KBSYM,057h, KBNUL,KBCAP,KBSYM,057h, KBNUL,KBCAP,KBSYM,057h, KBNUL
                    ; Page Up
                    db      KBCAP,047h, KBNUL,KBNUL,KBCAP,KBSYM,047h, KBNUL,KBCAP,KBSYM,047h, KBNUL,KBCAP,KBSYM,047h, KBNUL
                    db      KBCAP,047h, KBNUL,KBNUL,KBCAP,KBSYM,047h, KBNUL,KBCAP,KBSYM,047h, KBNUL,KBCAP,KBSYM,047h, KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; 
                    db      KBCAP,04Fh, KBNUL,KBNUL,KBCAP,KBSYM,04Fh, KBNUL,KBCAP,KBSYM,04Fh, KBNUL,KBCAP,KBSYM,04Fh, KBNUL
                    db      KBCAP,04Fh, KBNUL,KBNUL,KBCAP,KBSYM,04Fh, KBNUL,KBCAP,KBSYM,04Fh, KBNUL,KBCAP,KBSYM,04Fh, KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; 
                    db      KBCAP,053h, KBNUL,KBNUL,KBCAP,KBSYM,053h, KBNUL,KBCAP,KBSYM,053h, KBNUL,KBCAP,KBSYM,053h, KBNUL
                    db      KBCAP,053h, KBNUL,KBNUL,KBCAP,KBSYM,053h, KBNUL,KBCAP,KBSYM,053h, KBNUL,KBCAP,KBSYM,053h, KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; End
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; 
                    db      KBCAP,05Fh, KBNUL,KBNUL,KBCAP,KBSYM,05Fh, KBNUL,KBCAP,KBSYM,05Fh, KBNUL,KBCAP,KBSYM,05Fh, KBNUL
                    db      KBCAP,05Fh, KBNUL,KBNUL,KBCAP,KBSYM,05Fh, KBNUL,KBCAP,KBSYM,05Fh, KBNUL,KBCAP,KBSYM,05Fh, KBNUL
                    ; Page Down
                    db      KBCAP,043h, KBNUL,KBNUL,KBCAP,KBSYM,043h, KBNUL,KBCAP,KBSYM,043h, KBNUL,KBCAP,KBSYM,043h, KBNUL
                    db      KBCAP,043h, KBNUL,KBNUL,KBCAP,KBSYM,043h, KBNUL,KBCAP,KBSYM,043h, KBNUL,KBCAP,KBSYM,043h, KBNUL
                    ; Insert
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Delete
                    db      KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,0C7h, KBNUL,KBNUL,KBNUL
                    db      KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,KBNUL,0C7h, KBNUL,KBNUL,KBNUL
                    ; Print Screen
                    db      091h, KBNUL,KBNUL,KBNUL,091h, KBNUL,KBNUL,KBNUL,091h, KBNUL,KBNUL,KBNUL,091h, KBNUL,KBNUL,KBNUL
                    db      091h, KBNUL,KBNUL,KBNUL,091h, KBNUL,KBNUL,KBNUL,091h, KBNUL,KBNUL,KBNUL,091h, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    ; Unknown key
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL
                    db      0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL,0CFh, KBNUL,KBNUL,KBNUL


;****************************************************************************;

                end
